package checkers;



public class CheckersBoard
{
    public char board[][];
    public int heuristic;
    public boolean opponentBlack;
    boolean jumpMade;
    public String moveName;
    public CheckersBoard successors[];
    public int pointer;
    
    public CheckersBoard(boolean oB)
    {
        board = new char[8][8];
        opponentBlack =oB;
        getHeuristic();
        moveName = "";
        jumpMade = false;
        successors = new CheckersBoard[250];
        pointer = 0;
        
    }
    
        public void initializeBoard()
    {
        for(int i = 0; i<3; i++)
        {
            for(int j=0; j<8; j++)
            {
                if((i%2)==0 && (j%2)==0)
                {
                    board[i][j]='b';
                }
                
                else if((i%2)==1 && (j%2)==1)
                {
                    board[i][j]='b';
                }
                
                else 
                    board[i][j]='-';
            }
        }
        
        for(int i=5; i<8; i++)
        {
            for(int j=0; j<8; j++)
            {
                if((i%2)==0 && (j%2)==0)
                {
                    board[i][j]='r';
                }
                
                else if((i%2)==1 && (j%2)==1)
                {
                    board[i][j]='r';
                }
                
                else 
                    board[i][j]='-';
            }
        }
        
        for(int i=3; i<5; i++)
        {
            for(int j=0; j<8; j++)
            {
                board[i][j] ='-';
            }
        }
    }
    
    public void getHeuristic()
    {
        int black=0;
        int red = 0;
        for( int i=0; i<8; i++)
        {
            for( int j = 0; j<8; j++)
            {
                if(board[i][j]=='r')
                    red++;
                else if(board[i][j]=='b')
                    black++;
                else if(board[i][j]=='B')
                    black+=2;
                else if(board[i][j] == 'R')
                    red -=2;
            }
        }
            heuristic = black-red;
    }
    
    public void copyBoard(CheckersBoard a)
    {
        for(int i =0; i<8;i++)
        {
            for( int j=0; j<8; j++)
            {
                char temp = this.board[i][j];
                a.board[i][j] = temp;
            }
        }
    }
    
     public void printBoard()
    {
        for(int i=7; i>=0; i--)
        {
            for(int j=0; j<8; j++)
            {
                System.out.print(board[i][j]+"  ");
            }
            System.out.println();
        }
    }
        
    
    public void findJumps(int i, int j, CheckersBoard a, char color)
    {
        CheckersBoard b = new CheckersBoard(a.opponentBlack);
        CheckersBoard c = new CheckersBoard(a.opponentBlack);
        CheckersBoard d = new CheckersBoard(a.opponentBlack);
        CheckersBoard e = new CheckersBoard(a.opponentBlack);
        switch(color)
        {
            case 'b':
            {
                if(!a.isJump(i, j, i+2, j-2)&& !a.isJump(i, j, i+2, j+2))
                {
                    this.successors[pointer]= a;
                    this.successors[pointer].jumpMade=true;
                    this.successors[pointer].getHeuristic();
                    this.pointer++;
                }
                else 
                {
                    
                    if(a.isJump(i, j, i+2, j-2))//if can jump left
                    {
                        a.copyBoard(b);
                        b.move(i, j, i+2, j-2);
                        this.findJumps(i+2, j-2, b, 'b');
                        
                
                    }
            
                    if(a.isJump(i, j, i+2, j+2))
                    {
                        a.copyBoard(c);
                        c.move(i, j, i+2, j+2);
                        this.findJumps(i+2, j+2, c, 'b');
                        
                    }
                }
                break;
              }//ends b case   
              
              case 'r':
              {
                  if(!a.isJump(i, j, i-2, j-2)&& !a.isJump(i, j, i-2, j+2))
                {
                    this.successors[pointer]= a;
                    this.successors[pointer].jumpMade=true;
                    this.successors[pointer].getHeuristic();
                    this.pointer++;
                }
                else 
                {
                    //CheckersBoard b,c = new CheckersBoard(a.opponentBlack);
                    if(a.isJump(i, j, i-2, j-2))//if can jump left
                    {
                        a.copyBoard(b);
                        b.move(i, j, i-2, j-2);
                        this.findJumps(i-2, j-2, b, 'r');
                
                    }
            
                    if(a.isJump(i, j, i-2, j+2))
                    {
                        a.copyBoard(c);
                        c.move(i, j, i-2, j+2);
                        this.findJumps(i-2, j+2, c, 'r');
                    }
                }
                break;
            }//end r case
            case 'R':
            case 'B':
            {
                if(!a.isJump(i, j, i+2, j-2)&& !a.isJump(i, j, i+2, j+2)&&!a.isJump(i, j, i-2, j-2)&& !a.isJump(i, j, i-2, j+2))
                {
                    this.successors[pointer]=a;
                    this.successors[pointer].jumpMade=true;
                    this.successors[pointer].getHeuristic();
                    this.pointer++;
                }
                
                else
                {
                    //CheckersBoard b,c,d,e = new CheckersBoard(a.opponentBlack);
                    if(a.isJump(i, j, i+2, j-2))//if can jump left
                    {
                        a.copyBoard(b);
                        b.move(i, j, i+2, j-2);
                        this.findJumps(i+2, j-2, b, b.board[i][j]);
                                        
                    }
            
                    if(a.isJump(i, j, i+2, j+2))
                    {
                        a.copyBoard(c);
                        c.move(i, j, i+2, j+2);
                        this.findJumps(i+2, j+2, c, c.board[i][j]);
                    }
                     if(a.isJump(i, j, i-2, j-2))//if can jump left
                    {
                        a.copyBoard(d);
                        d.move(i, j, i-2, j-2);
                        this.findJumps(i-2, j-2, d, d.board[i][j]);
                
                    }
            
                    if(a.isJump(i, j, i-2, j+2))
                    {
                        a.copyBoard(e);
                        e.move(i, j, i-2, j+2);
                        this.findJumps(i-2, j+2, e, board[i][j]);
                    }
                }
                break;
            }//ends kings case
            default:
                {
                    this.successors[pointer]=a;
                    this.successors[pointer].getHeuristic();
                    this.successors[pointer].jumpMade=true;
                    this.pointer++;
                }
           }//end switch
         
       }//end findJumps
       
     public boolean isLegal(int i1, int j1, int i2, int j2)
    {
        if(i1<0 || i1>7 || j1<0 || j1>7 || i2<0 || i2>7 || j2<0 || j2>7)
            return false;
        switch(board[i1][j1])
        {
            case 'r':
                {
                    if((i1-i2==1 && ((j1-j2==1)||(j2-j1==1)))&&board[i2][j2]=='-')
                        return true;
                    else if (isJump(i1, j1, i2, j2)&& board[i2][j2]=='-')
                        return true;
                    else 
                        return false;
                }
            case 'b':
                {
                    if((i2-i1==1) && ((j1-j2==1)||(j2-j1==1))&&board[i2][j2]=='-')
                        return true;
                    else if (isJump(i1, j1, i2, j2))
                        return true;
                    else
                        return false;
                }
            case 'R':
            case 'B':
                {
                    if((((i2-i1==1) && ((j1-j2==1)||(j2-j1==1)))||(i1-i2==1 && ((j1-j2==1)||(j2-j1==1))))|| isJump(i1, j1, i2, j2)&& board[i2][j2]=='-')
                    {
                        return true;
                    }
                    else
                    return false;
                }
            default: 
                return false;
            
        }//end switch
        
    }//end isLegal
    
    public boolean isKing(int i2, int j2)
    {
        if(board[i2][j2]=='r' && i2==0)
            return true;
        else if(board[i2][j2]=='b' && i2==7)
            return true;
        else 
            return false;
    }
       
     public void move(int i1, int j1, int i2, int j2)
    {
        if(isLegal(i1, j1, i2, j2))
        {
            if(isJump(i1, j1, i2, j2))
            {
                  board[i2][j2]=board[i1][j1];
                  board[i1][j1]='-';
                  board[((i1+i2)/2)][((j1+j2)/2)]='-';
            }
            else
            {
                board[i2][j2]=board[i1][j1];
                board[i1][j1]='-';
            }
            if(isKing(i2, j2))
            {
                if(board[i2][j2]=='r')
                    board[i2][j2] = 'R';
                else
                    board[i2][j2] = 'B';
            }
        }
        else
        {
            System.out.println("Sorry, Illegal Move");
        }
    }
    
       
    public boolean isJump(int i1, int j1, int i2, int j2)
    {
        if(i1<0 || i1>7 || j1<0 || j1>7 || i2<0 || i2>7 || j2<0 || j2>7)
            return false;
        switch(board[i1][j1])
        {
            case 'r':
                {   //down right
                    if((((j2-j1)==2) && ((i1-i2)==2)))
                    {
                        if(board[i2][j2]=='-')
                        {
                            if(board[i1-1][j1+1]=='b' || board[i1-1][j1+1]=='B')
                                return true;
                            //break;
                        }
                        //might want to put some sort of error message
                    }
                    
                    //down left
                    if((i1-i2)==2 && (j1-j2)==2)
                    {
                        if(board[i2][j2]=='-')
                        {
                            if(board[i1-1][j1-1]=='b' || board[i1-1][j1-1]=='B')
                                return true;
                            //break;
                        }
                    }
                    return false;
                }
                   
           case  'b':
                {
                    //jump right by black
                    if((i2-i1)==2 &&(j2-j1)==2)
                    {
                        if(board[i2][j2]=='-')
                        {
                            if(board[i1+1][j1+1]=='r' || board[i1+1][j1+1] == 'R')
                                return true;
                        }
                    }        
                    
                    if(i2-i1==2 && j1-j2==2)
                    {
                        if(board[i2][j2]=='-')
                        {
                            if(board[i1+1][j1-1]=='r' || board[i1+1][j1-1] == 'R')
                                return true;
                        }
                    }
                    return false;
                }
                            
           case 'B':
           {
                //jump down left
                 if((((j1-j2)==2) && ((i1-i2)==2)))
                    {
                        if(board[i2][j2]=='-')
                        {
                            if(board[i1-1][j1-1]=='r' || board[i1-1][j1-1]=='R')
                                return true;
                            //break;
                        }
                        //might want to put some sort of error message
                    }
                  //jump down right  
                  if((i1-i2)==2 && (j2-j1)==2)
                  {
                      if(board[i2][j2]=='-')
                      {
                          if(board[i1-1][j1+1]=='r' || board[i1-1][j1+1]=='R')
                              return true;
                            //break;
                      }
                  }
                  
                  //jump up right
                  if((i2-i1)==2 &&(j2-j1)==2)
                  {
                      if(board[i2][j2]=='-')
                      {
                          if(board[i1+1][j1+1]=='r' || board[i1+1][j1+1] == 'R')
                              return true;
                      }
                  }        
                  
                  //jump up left  
                  if(i2-i1==2 && j1-j2==2)
                  {
                      if(board[i2][j2]=='-')
                      {
                          if(board[i1+1][j1-1]=='r' || board[i1+1][j1-1] == 'R')
                              return true;
                      }
                  }
                  return false;
           }        //ends case 'B'
           
           case 'R':
           {
                //jump down left
                 if((((j1-j2)==2) && ((i1-i2)==2)))
                    {
                        if(board[i2][j2]=='-')
                        {
                            if(board[i1-1][j1-1]=='b' || board[i1-1][j1-1]=='B')
                                return true;
                            //break;
                        }
                        //might want to put some sort of error message
                    }
                  //jump down right  
                  if((i1-i2)==2 && (j2-j1)==2)
                  {
                      if(board[i2][j2]=='-')
                      {
                          if(board[i1-1][j1+1]=='b' || board[i1-1][j1+1]=='B')
                              return true;
                            //break;
                      }
                  }
                  
                  //jump up right
                  if((i2-i1)==2 &&(j2-j1)==2)
                  {
                      if(board[i2][j2]=='-')
                      {
                          if(board[i1+1][j1+1]=='b' || board[i1+1][j1+1] == 'B')
                              return true;
                      }
                  }        
                  
                  //jump up left  
                  if(i2-i1==2 && j1-j2==2)
                  {
                      if(board[i2][j2]=='-')
                      {
                          if(board[i1+1][j1-1]=='b' || board[i1+1][j1-1] == 'B')
                              return true;
                      }
                  }
                  return false;
           }
           
           default:
                return false;
      }//ends swtich
      }//ends isjump
           
           
           
        

    public void successor(char player)
    {
        pointer = 0;
        CheckersBoard sBoard;
        switch(player)
        {
            case 'b':
            {
                for(int i=0; i<8; i++)
                {
                    for(int j=0; j<8; j++)
                    {
                        if(board[i][j] == 'b')
                        {
                            if(isLegal(i, j, i+1, j-1))
                            {
                                
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                //sBoard.moveName= 
                                sBoard.move(i, j, i+1, j-1);
                                sBoard.getHeuristic();
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            
                            if(isLegal(i, j, i+1, j+1))
                            {
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i+1, j+1);
                                sBoard.getHeuristic();
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            
                            if(isJump(i,j, i+2, j-2) || isJump(i,j, i+2, j+2))
                                findJumps(i, j, this, this.board[i][j]);
                         }
                        else if(board[i][j] =='B')
                        {
                            //move up left
                            if(isLegal(i, j, i+1, j-1))
                            {
                                
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i+1, j-1);
                                sBoard.getHeuristic();
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            //move up right
                            if(isLegal(i, j, i+1, j+1))
                            {
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i+1, j+1);
                                sBoard.getHeuristic();
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            
                             //move down left
                            if(isLegal(i, j, i-1, j-1))
                            {
                                
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i-1, j-1);
                                sBoard.getHeuristic();
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            
                            //move down right
                            if(isLegal(i, j, i-1, j+1))
                            {
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i-1, j+1);
                                sBoard.getHeuristic();
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            //check all jumps
                            if(isJump(i,j, i+2, j-2) || isJump(i,j, i+2, j+2)|| isJump(i,j, i-2, j-2) || isJump(i,j, i-2, j+2))
                                findJumps(i, j, this, this.board[i][j]);
                       }//ends else  
                    }//ends for
                    }//ends for
            }//ends case b
            
          case 'r':
          {
                for(int i=0; i<8; i++)
                {
                    for(int j=0; j<8; j++)
                    {
                        if(board[i][j] == 'r')
                        {
                            //move down left
                            if(isLegal(i, j, i-1, j-1))
                            {
                                
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i-1, j-1);
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            
                            //move down right
                            if(isLegal(i, j, i-1, j+1))
                            {
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i-1, j+1);
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            
                            if(isJump(i,j, i-2, j-2) || isJump(i,j, i-2, j+2))
                                findJumps(i, j, this, this.board[i][j]);
                        }
                        
                      else if(board[i][j] == 'R')
                      {
                          //move up left
                            if(isLegal(i, j, i+1, j-1))
                            {
                                
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i+1, j-1);
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            //move up right
                            if(isLegal(i, j, i+1, j+1))
                            {
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i+1, j+1);
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            
                             //move down left
                            if(isLegal(i, j, i-1, j-1))
                            {
                                
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i-1, j-1);
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            
                            //move down right
                            if(isLegal(i, j, i-1, j+1))
                            {
                                sBoard= new CheckersBoard(this.opponentBlack);
                                this.copyBoard(sBoard);
                                sBoard.move(i, j, i-1, j+1);
                                successors[pointer] = sBoard;
                                pointer++;
                            }
                            //check all jumps
                            if(isJump(i,j, i+2, j-2) || isJump(i,j, i+2, j+2)|| isJump(i,j, i-2, j-2) || isJump(i,j, i-2, j+2))
                                findJumps(i, j, this, this.board[i][j]);
                       }//ends else  
                    }//ends for
                }//ends for
            }//ends case
        }//ends switch
    }//ends successors()


}//end of class   
    
	