package checkers;

 
/*
 * Created on Mar 11, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author cslabuser
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Hueristic {


	public static int getBasicHeuristic(State Test){
		final int DEBUG = 0 ;
		long URPieces;
		long URKings;
		long THPieces;
		long THKings;
		final int URPIECES = -1;
		final int THPIECES = 1;
		final int URKINGS = 0;
		final int THKINGS = 0;
		
		if(Test.whiteMove){
			URPieces = numBits(Test.W);
			URKings = numBits(Test.W & Test.K);
			THPieces = numBits(Test.B);
			THKings = numBits(Test.B&Test.K);
		}
		else{
			URPieces = numBits(Test.B);
			URKings = numBits(Test.B&Test.K);
			THPieces = numBits(Test.W);
			THKings = numBits(Test.W & Test.K);
		}
		Long nP = new Long(URPieces);
		Long nK = new Long(URKings);
		Long nTP = new Long(THPieces);
		Long nTK = new Long(THKings);
		

		int hval = URPIECES*nP.intValue() + URKINGS*nK.intValue() + THPIECES *nTP.intValue() + THKINGS*nTK.intValue();
		if(nTP.intValue()==0) hval=Integer.MIN_VALUE;
		else if(nP.intValue()==0) hval = Integer.MAX_VALUE;
		
		if(DEBUG==1){
			System.out.println("\nTest.White move?: " + Test.whiteMove + " NP :"+ nP + " NK "+ nK + " Opp Piece " + nTP + " Opp King " + nTK);
			System.out.println("HVAL: " + hval);
		}
		return hval;
		
	}
	
	private static int numBits(long bistring){
		int count =0;
		long test = 0x400000000L;
		for(int i=36; i>0; i--){
			if((bistring & test) >0)
				count++;
			test = test >>1;	
		}
		return count;
	}
	
	public static int getBetterHuristic(State Test){
				final int DEBUG = 0 ;
				int URPieces;
				int URKings;
				int THPieces;
				int THKings;
			//	int URMiddle;
			//	int THMiddle;
				int myApex = Apex(Test);
				int URDeathPos;
				int THDeathPos;
				int hval = 0;
				int myClumpFactor = 0;
				int advancement = 0;
				int cent1 = cent1(Test);
				long whiteDeathMask = 0x100L;
				long blackDeathMask = 0x400000L;
				
				


				
				int URPIECES = -1000;
				int THPIECES = 1000;
				final int URKINGS = -400;
				//final int URMIDDLE = -50;
				final int URDEATHSPOT = -40;
				final int URCENT=-100;
				final int URAPEX=80;
				final int URCLUMP=80;
				final int URADVANCEMENT=50;
								
		
		
				if(Test.whiteMove){
					URPieces = numBits(Test.W);
					URKings = numBits(Test.W & Test.K);
					THPieces = numBits(Test.B);
					THKings = numBits(Test.B&Test.K);
					URDeathPos = numBits(Test.W & whiteDeathMask);
					THDeathPos = numBits(Test.B & blackDeathMask);
					myClumpFactor = numberClumps(Test.W);
					advancement = advancement(Test.B, Test.whiteMove);
					
				}
				else{
					URPieces = numBits(Test.B);
					URKings = numBits(Test.B&Test.K);
					THPieces = numBits(Test.W);
					THKings = numBits(Test.W & Test.K);
					URDeathPos = numBits(Test.B & blackDeathMask);
					THDeathPos = numBits(Test.B & blackDeathMask);
					myClumpFactor = numberClumps(Test.B);
					advancement = advancement(Test.W, Test.whiteMove);
				}
				
				if(URPieces == 0) return Integer.MAX_VALUE;
				if(THPieces == 0) return Integer.MIN_VALUE;
				
				if(URPieces<THPieces){
					URPIECES = -700;
					THPIECES = 1000;
				}
				else if(URPieces > THPieces){
					URPIECES =-1200;
					THPIECES = 1000;
				}
			
				int pieceVal = URPieces - THPieces;
				int kingVal = URKings - THKings;
				int deathVal = URDeathPos-THDeathPos;
				
				if (URPieces + THPieces >= 8){
					hval = URPieces * URPIECES + THPieces*THPIECES + (kingVal*URKINGS) + (deathVal*URDEATHSPOT)
							+(24-URPieces+THPieces)+(cent1*URCENT)+(myApex * URAPEX)+
									(advancement *URADVANCEMENT)+(myClumpFactor*URCLUMP);
				}
				else{
					hval = URPieces * URPIECES + THPieces*THPIECES + (kingVal*(-1*URKINGS)) +(24-URPieces+THPieces)+(cent1*URCENT)+(myApex * URAPEX)+
									(advancement *URADVANCEMENT)+(myClumpFactor*URCLUMP);
				}	
				
//			if(DEBUG==1){
//					System.out.println("\nTest.White move?: " + Test.whiteMove + " NP :"+ nP + " NK "+ nK + " Opp Piece " + nTP + " Opp King " + nTK);
//					System.out.println("HVAL: " + hval);
//				}
				return hval;		
			}
	
	
	public static int numberClumps(long Board)
	{
		long Mask = 0x623;
		int count = 0;
		for (int x = 0; x <= 31; x++){
			long currentVal = ((Mask << x) & Board);
			currentVal >>= x;
			if ((currentVal & 0x020) > 0 ){
				if((currentVal & 0x400) > 0 ) {count++;}
				if((currentVal & 0x200) > 0 ) {count++;}
				if((currentVal & 0x002) > 0) {count++;}
				if((currentVal & 0x001) > 0) {count++;}
			}
		}
		return count;
	}
	
	
	//returns the number/postion ration of the enemies pieces. 
	public static int advancement(long Board, boolean whiteMove)
	{
		int count = 0;
		long goodMask;
		long badMask;
		if (!whiteMove){
			 goodMask = 0x40000000;
			 badMask =0x1000;
		} else {
			 goodMask = 0x1000;
			 badMask =0x40000000;
		}
		
		for(int x = 9; x>=0; x--)
		{
			if (((goodMask >> (9-x))& Board) >0) count++;
			if (((badMask >>(9-x))&Board)>0) count --;
		}
		return (count);
		
	}
	
//	APEX
	public static int Apex(State s){
		int val = 0;
	 if(s.whiteMove){
		 if ((((s.W & 0x4000040L)>0) && (s.B & 0x4000040L)==0) && (s.K==0))
			 return 1;
	 }
	 else{ 
		 if(((s.W & 0x4000040L)==0)&& ((s.B & 0x4000040L)>0) && (s.K==0))
			 return 1;
	 }
	 return 0;
	}
	
	public static int cent1(State s){
				int count=0;
				long mask = 0xAA19800L;
				long white = s.W & mask;
				long black = s.B & mask;
			
				long tm = 0x8000000L;
				for(int i=28; i>0; i--){
					long isWhite = white & tm;
					long isBlack = black & tm;
					if (s.whiteMove){  
						if(isWhite > 0)
						  count--;
						else if(isBlack>0)
						  count++;
					}
					else{
						if(isWhite>0)
							count++;
						else if(isBlack>0)
							count--;
					}
					tm = tm >> 1;	
			}
		return count;
		}
	}
