/*
 * Created on Mar 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package search;
import java.util.ArrayList;
import java.util.Hashtable;

import checkers.BitBoard;
import checkers.State;
/**
 * @author daltonj
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AlphaBetaWithMemory {
	private final static int DEBUG = 1;
	private static Hashtable speedy;
	private static final int INFINITY = Integer.MAX_VALUE;
	private static final long MAX = 0x7ffffffffL;
	private static ArrayList successors;
	
	private static int OrigDepth;
	
	public static State AlphaBetaSearch(State state, int depth){
		speedy = new Hashtable(2097152);
		OrigDepth = depth;
		successors = new ArrayList();
		System.out.println("Starting A-B with: " + state.toString());
		BitBoard tmpBoard = new BitBoard(state,AlphaBetaTest.hashy);
		if(DEBUG==1){
			System.out.println("********* Gonna start alpha beta! with Depth: " + depth+ "\n NEXT STATES: ");
			AlphaBetaTest.outputState(tmpBoard);
			}
		int v = MaxValue(state,depth,-INFINITY,INFINITY);	
		for(int i =0; i< successors.size(); i++){
			State t1 = (State)successors.get(i);
			if(t1.v == v)
				return t1;
		}
		return null;	// never should be called!	
	}
	
	public static int MaxValue(State state, int depth, int alpha, int beta){
		State n = (State) speedy.get(generateKey(state));
		if(n!=null){
		//	System.out.println("FOUND SOMETHING");
			if(n.lower >= beta) return n.lower;
			alpha = Math.max(alpha,n.lower);
		}
		if (TerminalTest(state, depth))
			return state.hueristicVal;
		
		BitBoard tmpBoard = new BitBoard(state,AlphaBetaTest.hashy);
		if(DEBUG==1) System.out.println("Doing Max! with Depth: " + depth+ " alpha:" +alpha + " beta: " + beta);                                                                                                                                                                                                                      

		int v = -INFINITY;
		--depth;
		for(int i =0; i< tmpBoard.nStates.size(); i++)
		{
			State s = (State)tmpBoard.nStates.get(i);
			v =  Math.max(v,MinValue(s,depth,alpha,beta));
			state.v = v;
			if(v>=beta){
				state.v = v;
				state.lower =v;
				speedy.put(generateKey(state),state);
				return v;
			}
			alpha = Math.max(alpha,v);
		}
		if(DEBUG==1)System.out.println("MAX IS GIVING YOU: "+ v);
//		if (OrigDepth-depth == 1){
//			successors.add(state);
//		}
		return v;
	}
	
	public static int MinValue(State state, int depth, int alpha, int beta){
		// get values from lookup table
		State n1 = (State) speedy.get(generateKey(state));
		if(n1!=null){
		//	System.out.println("FOUND SOMETHING");
			if(n1.upper <= alpha) return n1.upper;
			beta = Math.min(beta,n1.upper);
		}
		if (TerminalTest(state, depth))
			return state.hueristicVal;
		BitBoard tmpBoard = new BitBoard(state,AlphaBetaTest.hashy);
		if(DEBUG==1) System.out.println("Doing Min! with Depth: " + depth + " alpha:" +alpha + " beta: " + beta);      
		int v = INFINITY;
		--depth;
		for(int i =0; i< tmpBoard.nStates.size(); i++)
		{
			State s = (State)tmpBoard.nStates.get(i);
			v =  Math.min(v,MaxValue(s,depth,alpha,beta));
			state.v = v;
			if(v<=alpha){
				state.v = v;
				state.upper = v;
				speedy.put(generateKey(state),state);
				return v;
			}
			beta = Math.min(beta,v);
		}
		if(DEBUG==1)System.out.println("MIN IS GIVING YOU: "+ v);
		
		if (OrigDepth-depth == 2){
			successors.add(state);
		}
		
		return v;

		}
		
	
	public static boolean TerminalTest(State s, int depth){
		if ((s.B & MAX) ==0 || (s.W & MAX) ==0|| depth <= 0)
			return true;
		else return false;
	}
	
	public static void outputState(ArrayList l){
		for(int i=0; i<l.size();i++){
			State nState = (State)l.get(i);
			System.out.print(nState.toString());
			System.out.print("V Value: " + nState.v);
		}
	}
	
	public static Long generateKey(State s){
		
		return new Long((s.B|s.W));
		
	}

}
