/**
 * REDS!
 * 
 * @author Andrew Burke & Grant Lanterman
 * @version 3/11/04
 */
import java.lang.*;
import java.util.*;
import java.io.*;
public class Reds
{
    // instance vars
    private checkerState gameState;
    private checkerState lastState;
    private boolean MAX = false;
    private int moveCount = 0;
    private int otherStateIndex = 0;
    private static int MAXINT = 0x7FFFFFFF;
    private static int MININT = 0x80000000;
    private static int DEFPLYLEVEL = 8;
    private static int PIECE4PLYLEVEL = 10;
    private boolean LEVEL4 = false;
    private int currPlyLevel = DEFPLYLEVEL;
    private static Vector board = new Vector();
    private boolean flip = false;
    
    // constructors
    public Reds(boolean side)
    {
        gameState = new checkerState();
        flip = side;
        run();
    } // end constructor
    
    private void run()
    {
    for(int i = 0; i < 33; i++) {
            board.add(gameState.getAdjacentSquares(i));
        }

        String in = "";
        String[] move;
        char turn = 'w';
        int piece = 0;
        int target = 0;
        int[] moves;
        boolean goodMove;
        boolean sure = false;
        String choice = "";
        String out = "";
        System.out.println(gameState.toString(flip)+"\n");
        while(true) {
            try {
                if(gameOver())
                    break;
                //white's move
                if(turn == 'r')
                {
                    System.out.println("Red's Move");
                    //find the next state
                    gameState = miniMax(gameState);
                    out = gameState.getMove();
                    if(flip)  out = flipIt(out);
                    System.out.println("Move Selected: "+out);
                    gameState = gameState.coronate(gameState);
                    System.out.println();
                    moveCount++;
                    if(gameOver())
                        break;
                    turn = 'w';
                }
                //red's move
                if(turn == 'w'){
                while(true)
                {
                    System.out.println(gameState.toString(flip));
                    System.out.println("White's Move");
                    System.out.print("Please Enter Move (#-#-...#): ");
                    in = readLine();
                    
                    while(!sure) {
                        System.out.println("Are you sure? (y for yes, n for no): ");
                        choice = readLine();
                        if(choice.equals("y"))
                            break;
                        else {
                            System.out.print("Please Enter Move (#-#-...#): ");
                            in = readLine();
                        }
                    } // end while(!sure)
                    
                    if(in.equals("UNDO"))
                    {
                        in = "";
                        moveCount-=2;
                        gameState = new checkerState(lastState);
                        break;
                    }
                    else
                    {
                        if(flip)  in = flipIt(in);
                        lastState = new checkerState(gameState);
                        move = in.split("-");
                        // put moves into an int array
                        moves = new int[move.length];
                        //check for legal move
                        for(int i = 0; i < moves.length; i++)
                        moves[i] = Integer.parseInt(move[i]); 
                        // make the move
                        goodMove = isLegalMove(moves, gameState, turn);
                        if(goodMove) {
                            gameState = move(gameState, moves);
                            gameState = gameState.coronate(gameState);
                            System.out.println(gameState.toString(flip));
                            moveCount++;
                            turn = 'r';
                            break;
                        }
                        else {
                            System.out.println("Illegal Move!");
                        }
                    }
                }}
             }
             catch(IOException e) {
                System.out.println("Error Reading Input!");
             }
         } // end game loop
         System.out.println("Total Moves Required: "+moveCount);
    } // end run()
    
    public String flipIt(String in)
    {
        StringBuffer inSB = new StringBuffer(in);
        String temp;
        String out = "";
        int bob = 0;
        while(inSB.indexOf("-") > 0)
        {
            temp = inSB.substring(0,inSB.indexOf("-"));
            bob = Integer.parseInt(temp);
            out += lookup(bob) +"-";
            inSB.delete(0,inSB.indexOf("-")+1);
        }
        bob = Integer.parseInt(inSB.toString());
        out += lookup(bob);
        return out;
    }
    
    private int lookup(int joe)
    {
        int bob = 0;
        // find adjacent squares to a location
                switch(joe)
                {
                    case 1: bob = 32; break;
                    case 2: bob = 31; break;
                    case 3: bob = 30; break;
                    case 4: bob = 29; break;
                    case 5: bob = 28; break;
                    case 6: bob = 27; break;
                    case 7: bob = 26; break;
                    case 8: bob = 25; break;
                    case 9: bob = 24; break;
                    case 10: bob = 23; break;
                    case 11: bob = 22; break;
                    case 12: bob = 21; break;
                    case 13: bob = 20; break;
                    case 14: bob = 19; break;
                    case 15: bob = 18; break;
                    case 16: bob = 17; break;
                    case 17: bob = 16; break;
                    case 18: bob = 15; break;
                    case 19: bob = 14; break;
                    case 20: bob = 13; break;
                    case 21: bob = 12; break;
                    case 22: bob = 11; break;
                    case 23: bob = 10; break;
                    case 24: bob = 9; break;
                    case 25: bob = 8; break;
                    case 26: bob = 7; break;
                    case 27: bob = 6; break;
                    case 28: bob = 5; break;
                    case 29: bob = 4; break;
                    case 30: bob = 3; break;
                    case 31: bob = 2; break;
                    case 32: bob = 1; break;
                    default: bob = 0; break;
                }
            return bob;
        }
    
    private boolean isLegalMove(int[] moves, checkerState cs, char turn)
    {
        //piece has not moved
        if(moves[0] == moves[moves.length-1])
                    return false;
        //Source Empty
        else if(cs.isClear(moves[0]))
            return false;
        //destination space is occupied
        else if(!cs.isClear(moves[moves.length-1]))
            return false;
        else if((turn == 'r') && ((cs.getPieces().charAt(moves[0]) != 'r') && (cs.getPieces().charAt(moves[0]) != 'R')))
            return false;
        else if((turn == 'w') && ((cs.getPieces().charAt(moves[0]) != 'w') && (cs.getPieces().charAt(moves[0]) != 'W')))
            return false;
        return true;
      }
  
    // detect if there are any jumps on teh board
    private boolean detectJumps(String s)
    {
        for(int i = 0; i < s.length(); i++)
        {
            if(isWhiteJump(s, i) && MAX)
                return true;
            else if(isRedJump(s, i) && !MAX)
                return true;      
        }
        return false;
    } // end detectJumps()
    
    private boolean isWhiteJump(String s, int piece)
    {
        //look at location target
        checkerState cs = new checkerState(s);
        int[] nextSquares = (int[])board.get(piece);
        //for each possible square, if there is an enemy piece in any of those squares return true
        for(int i = 0; i < nextSquares.length; i++)
        {
            if(s.charAt(piece) == 'W')
            {
                if(s.charAt(nextSquares[i]) == 'r' || s.charAt(nextSquares[i]) == 'R')
                {
                    int[] jumpSquares = (int[])board.get(nextSquares[i]);
                    for(int j = 0; j < jumpSquares.length; j++)
                    {
                        if (((Math.abs(piece - jumpSquares[j]) % 2) != 0) && (Math.abs(piece - jumpSquares[j]) != 1) && (cs.isClear(jumpSquares[j])))
                            return true;
                    }
                }
            }
            else if(s.charAt(piece) == 'w')
            {
                if(s.charAt(nextSquares[i]) == 'R' || s.charAt(nextSquares[i]) == 'r') {
                    if(nextSquares[i] < piece)
                    {
                        int[] jumpSquares = (int[])board.get(nextSquares[i]);
                        for(int j = 0; j < jumpSquares.length; j++)
                        {
                            if (((Math.abs(piece - jumpSquares[j]) % 2) != 0) && (Math.abs(piece - jumpSquares[j]) != 1) && (cs.isClear(jumpSquares[j]))) {
                                return true;
                            }
                        }
                    }
                }
            }
        }// end for loop
        return false;
    } // end isWhiteJump()
    
    private boolean isRedJump(String s, int piece)
    {
        //look at location target
        checkerState cs = new checkerState(s);
        int[] nextSquares = (int[])board.get(piece);
        //for each possible square, if there is an enemy piece in any of those squares return true
        for(int i = 0; i < nextSquares.length; i++)
        {
            if(s.charAt(piece) == 'R')
            {
                if(s.charAt(nextSquares[i]) == 'w' || s.charAt(nextSquares[i]) == 'W')
                {
                    int[] jumpSquares = (int[])board.get(nextSquares[i]);
                    for(int j = 0; j < jumpSquares.length; j++)
                    {
                        if (((Math.abs(piece - jumpSquares[j]) % 2) != 0) && (Math.abs(piece - jumpSquares[j]) != 1) && (cs.isClear(jumpSquares[j])))
                            return true;
                    }
                }
            }
            else if(s.charAt(piece) == 'r')
            {
                if(s.charAt(nextSquares[i]) == 'W' || s.charAt(nextSquares[i]) == 'w') 
                {
                    if(nextSquares[i] > piece)
                    {
                        int[] jumpSquares = (int[])board.get(nextSquares[i]);
                        for(int j = 0; j < jumpSquares.length; j++)
                        {
                            if (((Math.abs(piece - jumpSquares[j]) % 2) != 0) && (Math.abs(piece - jumpSquares[j]) != 1) && (cs.isClear(jumpSquares[j])))
                                return true;
                        }
                    }
                }
            }
        }// end for loop
        return false;
    } // end isRedJump()
                
    // see if there is a jump for any piece
    private boolean isJump(String s, int piece)
    {
        //look at location target
        checkerState cs = new checkerState(s);
        int[] nextSquares = (int[])board.get(piece);
        //for each possible square, if there is an enemy piece in any of those squares return true
        for(int i = 0; i < nextSquares.length; i++)
        {
            if(s.charAt(piece) == 'W')
            {
                if(s.charAt(nextSquares[i]) == 'r' || s.charAt(nextSquares[i]) == 'R')
                {
                    int[] jumpSquares = (int[])board.get(nextSquares[i]);
                    for(int j = 0; j < jumpSquares.length; j++)
                    {
                        if (((Math.abs(piece - jumpSquares[j]) % 2) != 0) && (Math.abs(piece - jumpSquares[j]) != 1) && (cs.isClear(jumpSquares[j])))
                        {
                            return true;
                        }
                    }
                }
            }
            else if(s.charAt(piece) == 'w')
            {
                if(s.charAt(nextSquares[i]) == 'R' || s.charAt(nextSquares[i]) == 'r') {
                    if(nextSquares[i] < piece)
                    {
                        int[] jumpSquares = (int[])board.get(nextSquares[i]);
                        for(int j = 0; j < jumpSquares.length; j++)
                        {
                            if (((Math.abs(piece - jumpSquares[j]) % 2) != 0) && (Math.abs(piece - jumpSquares[j]) != 1) && (cs.isClear(jumpSquares[j])))
                            {
                                return true;
                            }
                        }
                    }
                }
            }
            else if(s.charAt(piece) == 'R')
            {
                if(s.charAt(nextSquares[i]) == 'w' || s.charAt(nextSquares[i]) == 'W')
                {
                    int[] jumpSquares = (int[])board.get(nextSquares[i]);
                    for(int j = 0; j < jumpSquares.length; j++)
                    {
                        if (((Math.abs(piece - jumpSquares[j]) % 2) != 0) && (Math.abs(piece - jumpSquares[j]) != 1) && (cs.isClear(jumpSquares[j])))
                        {
                            return true;
                        }
                    }
                }
            }
            else if(s.charAt(piece) == 'r')
            {
                if(s.charAt(nextSquares[i]) == 'W' || s.charAt(nextSquares[i]) == 'w') {
                    if(nextSquares[i] > piece)
                    {
                        int[] jumpSquares = (int[])board.get(nextSquares[i]);
                        for(int j = 0; j < jumpSquares.length; j++)
                        {
                            if (((Math.abs(piece - jumpSquares[j]) % 2) != 0) && (Math.abs(piece - jumpSquares[j]) != 1) && (cs.isClear(jumpSquares[j])))
                                return true;
                        }
                    }
                }
            }
        }
        return false;
        //if it has a jump return true
    } // end isJump()
    
    private checkerState getJumpState(checkerState currState, int piece, boolean isFirstJump)
    {
        //Store all possible next states for later consideration
        Vector returnStates = new Vector();
        //base case
        if(!isJump(currState.getPieces(),piece))
        {
            //No remaining jumps
            return currState;
        }
        else
        {
            String pieces = currState.getPieces();
            int[] adjSquares = (int[])board.get(piece);
            //if it is a king
            if((pieces.charAt(piece) == 'W') || (pieces.charAt(piece) == 'R'))
            {
                // consider all squares
                for(int i = 0; i<adjSquares.length; i++)
                {
                    //if next space is an enemy
                    if(((pieces.charAt(piece) == 'W') && (pieces.charAt(adjSquares[i]) == 'r' || pieces.charAt(adjSquares[i]) == 'R')) || ((pieces.charAt(piece) == 'R') && (pieces.charAt(adjSquares[i]) == 'w' || pieces.charAt(adjSquares[i]) == 'W')) && currState.isClear(findDestination(currState,piece,adjSquares[i])))
                    {
                        //build a new checkerState based on jumping that square and add it to the Vector
                        returnStates.add(getJumpState(jump(currState,piece,adjSquares[i], isFirstJump),findDestination(currState,piece,adjSquares[i]), false));
                    }
                }
            }
            //if it is a red piece
            else if(pieces.charAt(piece) == 'r')
            {
                //consider only squares greater than piece
                for(int i = 0; i<adjSquares.length; i++)
                {
                    //if next space is an enemy AND it is greater than current space
                    if(((pieces.charAt(adjSquares[i]) == 'w') || (pieces.charAt(adjSquares[i]) == 'W')) && (adjSquares[i] > piece) && currState.isClear(findDestination(currState,piece,adjSquares[i])))
                    {
                        //build a new checkerState based on jumping that square and add it to the Vector
                        returnStates.add(getJumpState(jump(currState,piece,adjSquares[i], isFirstJump),findDestination(currState,piece,adjSquares[i]), false));
                    }
                }
            }
            //else it must be a white piece
            else if(pieces.charAt(piece) == 'w')
            {
                //consider only squares less than piece
                for(int i = 0; i<adjSquares.length; i++)
                {
                    //if next space is an enemy AND it is less than current space
                    if(((pieces.charAt(adjSquares[i]) == 'r') || (pieces.charAt(adjSquares[i]) == 'R')) && (adjSquares[i] < piece) && currState.isClear(findDestination(currState,piece,adjSquares[i])))
                    {
                        //build a new checkerState based on jumping that square and add it to the Vector
                        returnStates.add(getJumpState(jump(currState,piece,adjSquares[i], isFirstJump),findDestination(currState,piece,adjSquares[i]), false));
                    }
                }
            }
        }
        return (checkerState)returnStates.get(0);
    }
    
    // find the destination square of a jump
    public int findDestination(checkerState cs, int piece, int victim) {
        int[] nextSquares = (int[])board.get(victim);
        for(int i = 0; i < nextSquares.length; i++) {
            if((Math.abs(piece - nextSquares[i])) % 2 != 0 && (Math.abs(piece - nextSquares[i])) != 1 && cs.isClear(nextSquares[i]))
                return nextSquares[i];
        }
        return 0;
    } // end findDestination()
    
    // decide if there is a jump for a cretain piece to a certain destination
    public boolean isThereAJumpFor(checkerState cs, int piece, int victim) {
        int[] nextSquares = (int[])board.get(victim);
        for(int i = 0; i < nextSquares.length; i++) {
            if((Math.abs(piece - nextSquares[i])) % 2 != 0 && (Math.abs(piece - nextSquares[i])) != 1 && cs.isClear(nextSquares[i]))
                return true;
        }
        return false;
    } // end isThereAJumpFor()
    
    // execute a move, jump if needed.
    public checkerState move(checkerState cs, int[] move) {
        checkerState moveState = new checkerState(cs);
        char temp;
        if(isJump(moveState.getPieces(), move[0]) && move.length == 2) {
            moveState = jump(moveState, move[0], findVictim(move[0],move[1]), true);
        }
        else if(move.length == 2) {
            temp = (moveState.getPieces()).charAt(move[0]);
            moveState.remove(move[0]);
            moveState.add(move[1], temp);
            moveState.setMove(move[0] + "-" + move[1]);
        }
        // execute a jump
        else {
            for(int i = 0; i < move.length-1; i++)
                moveState = jump(moveState, move[i], findVictim(move[i], move[i+1]),true);
        }
        return moveState;
    } // end move()
    
    // find the victim piece of a jump
    public int findVictim(int piece, int target) {
        // need to find the square that has target in its adjacency
        int[] pieceSquares = (int[])board.get(piece);
        int temp = 0;
        int[] tempSquares;
        for(int i = 0; i < pieceSquares.length; i++) {
            tempSquares = (int[])board.get(pieceSquares[i]);
            for(int j = 0; j < tempSquares.length; j++) {
                if(tempSquares[j] == target)
                    temp = pieceSquares[i];
            } // end inner for loop
        } // end outter for loop
        return temp;
    } // end findVictim()
    
    // make a king if need be
    public char kingMe(char c, int i) {
        if(c == 'R' || c == 'W')
            return c;
        else if(c == 'r') {
            if(i == 29 || i == 30 || i == 31 || i == 32)
                return 'R';
            else
                return 'r';
        }
        else {
            if(i == 1 || i == 2 || i == 3 || i == 4)
                return 'W';
            else
                return 'w';
        } 
    } // end kingMe()
    
    //Make kings if necessary
    
    
    // execute a jump
    private checkerState jump(checkerState cs, int piece, int victim, boolean first)
    {
        //EVEN difference between target and nextsquares from victim is bad
        //odd  = good
        String s = cs.getPieces();
        checkerState currState = new checkerState(cs);
        checkerState returnState = new checkerState(cs);
        int[] nextSquares = (int[])board.get(victim);
        for(int i = 0; i < nextSquares.length; i++)
        {
            if (((Math.abs(piece - nextSquares[i]) % 2) != 0) && (Math.abs(piece - nextSquares[i]) != 1))
            {
                //remove victim
                returnState.remove(victim);
                
                if(s.charAt(piece) == 'W')
                {
                    returnState.remove(piece);
                    returnState.add(nextSquares[i], 'W');
                }
                else if(s.charAt(piece) == 'w')
                {
                    returnState.remove(piece);
                    returnState.add(nextSquares[i], 'w');
                }
                if(s.charAt(piece) == 'R')
                {
                    returnState.remove(piece);
                    returnState.add(nextSquares[i], 'R');
                }
                else if(s.charAt(piece) == 'r')
                {
                    returnState.remove(piece);
                    returnState.add(nextSquares[i], 'r');
                }
                if(first)
                {
                    returnState.setMove(piece+"-"+nextSquares[i]);
                }
                else
                {
                    returnState.addMove("-" + nextSquares[i]);
                }
                break;
            }
        }
        return returnState;
    } // end jump()
 
    // is there a move for a certain piece that isnt a jump
    public boolean isMove(int piece, checkerState state) {
        String s = state.getPieces();
        int[] adjacentSquares = (int[])board.get(piece);
        if((s.charAt(piece) == 'W') || (s.charAt(piece) == 'R')) {
            for(int i = 0; i < adjacentSquares.length; i++)
                if(state.isClear(adjacentSquares[i]))
                    return true;
        }
        else if(s.charAt(piece) == 'w') {
            for(int i = 0; i < adjacentSquares.length; i++)
                if(state.isClear(adjacentSquares[i]) && adjacentSquares[i] < piece)
                    return true;}
        else if(s.charAt(piece) == 'r') {
            for(int i = 0; i < adjacentSquares.length; i++)
                if(state.isClear(adjacentSquares[i]) && adjacentSquares[i] > piece)
                    return true;}
        
        return false;
            
    } // end isMove()
 
    // get the next state depending on isMax
    public checkerState getNextStates(checkerState currState) {
        checkerState nextState = new checkerState(currState);
        checkerState tempState;
        String pieces = nextState.getPieces();
        //System.out.println("MAX = "+MAX);
       // System.out.println("detect jumps = " + detectJumps(pieces));
        if(detectJumps(pieces) && MAX) {
            //add jumps possible 
            //for all pieces
            for(int i=1; i< pieces.length(); i++)
            {
                //if the piece can make the jump
                if(isWhiteJump(pieces, i))
                {
                    //get the resultant state
                    tempState = new checkerState(getJumpState(currState, i,true));
                    tempState.setParent(nextState);
                    nextState.addChild(tempState);
                }
            }
        }
        else if(detectJumps(pieces) && !MAX) {
            //add jumps possible 
            //for all pieces
            for(int i=1; i< pieces.length(); i++)
            {
                //if the piece can make the jump
                if(isRedJump(pieces, i))
                {
                    //get the resultant state
                    tempState = new checkerState(getJumpState(currState, i,true));
                    tempState.setParent(nextState);
                    nextState.addChild(tempState);
                }
            }
        }
        else {
            for(int i = 1; i < pieces.length(); i++) 
            { 
                if(isMove(i, nextState))
                {
                    // add the moves that piece i can do as states to the children of nextState
                    //get i's adjacent squares
                    
                    int[] adjacentSquares = (int[])board.get(i);
                    //for each adjacent square, build a new state based on moving that piece there
                    for(int j = 0; j < adjacentSquares.length; j++)
                    {
                        //make sure it is one of our pieces we are moving
                        if(MAX)
                        {
                            if(((pieces.charAt(i) == 'W') && (nextState.isClear(adjacentSquares[j]))))
                            {
                                tempState = new checkerState(nextState);
                                tempState.add(adjacentSquares[j],pieces.charAt(i));
                                tempState.remove(i);
                                tempState.setMove(i+"-"+adjacentSquares[j]);
                                tempState.setParent(nextState);
                                nextState.addChild(tempState);
                            }
                            else if(pieces.charAt(i) == 'w' && nextState.isClear(adjacentSquares[j]) && adjacentSquares[j] < i)
                            {
                                tempState = new checkerState(nextState);
                                tempState.add(adjacentSquares[j],pieces.charAt(i));
                                tempState.remove(i);
                                tempState.setMove(i+"-"+adjacentSquares[j]);
                                tempState.setParent(nextState);
                                nextState.addChild(tempState);
                            }
                        }
                        else
                        //red's pieces go
                        {
                            if((pieces.charAt(i) == 'R') && (nextState.isClear(adjacentSquares[j])))
                            {
                                tempState = new checkerState(nextState);
                                tempState.add(adjacentSquares[j],pieces.charAt(i));
                                tempState.remove(i);
                                tempState.setMove(i+"-"+adjacentSquares[j]);
                                tempState = tempState.coronate(tempState);
                                tempState.setParent(nextState);
                                nextState.addChild(tempState);
                            }
                            if((pieces.charAt(i) == 'r') && (nextState.isClear(adjacentSquares[j])) && adjacentSquares[j] > i)
                            {
                                tempState = new checkerState(nextState);
                                tempState.add(adjacentSquares[j],pieces.charAt(i));
                                tempState.remove(i);
                                tempState.setMove(i+"-"+adjacentSquares[j]);
                                tempState = tempState.coronate(tempState);
                                tempState.setParent(nextState);
                                nextState.addChild(tempState);
                            }
                        }                        
                    }
                }
            }
            }
        if(MAX) MAX = false;
        else MAX = true;
        return nextState;
    } // end getNextState()        
    
    
    
    // calculate the next best state using minimax
    private checkerState miniMax(checkerState currState)
    {
        MAX = false;
        //change ply level max
        if(totalPieces(currState) < 5 && !LEVEL4)
        {
            System.out.println("Updated for 4 piece condition!");
            currPlyLevel = PIECE4PLYLEVEL;
            LEVEL4 = true;
        }   
        currState = getNextStates(currState);
        try {
        Vector kids = currState.getChildren();
        checkerState bestState = (checkerState)kids.get(0);
        int bestVal = MINValue(bestState, MININT, MAXINT, 0);
        int temp = 0;
            for(int i=1; i<kids.size(); i++)
            {
                //System.out.println("Now Considering kids.get("+i+")");
                temp = MINValue((checkerState)kids.get(i),MININT,MAXINT, 0);
                if(temp<bestVal)
                {
                    //System.out.println("New bestVal found in Minimax value = "+temp);
                    bestVal = temp;
                    bestState = (checkerState)kids.get(i);
                }
            }
        System.out.println("bestVal: " + bestVal);
        return bestState;
        }
        catch(Exception e) {
            System.out.println("We win cause we ain't movin no where foo!");
            System.exit(0);
        }
        return currState;
    } // end miniMax()

    private int MAXValue(checkerState cs, int alpha, int beta, int plyLevel)
    {
        plyLevel++;
        if(isTerminal(cs,plyLevel))
        {
            //System.out.println("Base Case Reached in MAX Value: " + cs.getValue() + " on ply level "+plyLevel);
            return getValue(cs);
        }
        cs = getNextStates(cs);
        Vector childs = cs.getChildren();
        int v = MININT;
        for(int i=0; i< childs.size(); i++)
        {
            v = Math.max(v, MINValue((checkerState)childs.get(i), alpha, beta, plyLevel));
            if(v >= beta) {
            //System.out.println("beta cutoff");
            break;
        }
        alpha = Math.max(alpha, v);
        }
        //System.out.println("value v= " + v + " on ply level "+plyLevel+" returned from end of method in MAX");
        return v;
    }
    
    private int MINValue(checkerState cs, int alpha, int beta, int plyLevel)
    {
        plyLevel++;
        if(isTerminal(cs,plyLevel))
        {
            //System.out.println("Base Case Reached in MIN Value: " + cs.getValue() + " on ply level "+plyLevel);
            return getValue(cs);
        }
        cs = getNextStates(cs);
        Vector childs = new Vector();
        childs = cs.getChildren();
        int v = MAXINT;
        for(int i=0; i< childs.size(); i++)
        {
            v = Math.min(v, MAXValue((checkerState)childs.get(i), alpha, beta, plyLevel));
            if(v <= alpha) {
            //System.out.println("alpha cutoff");
            break;
        }
        beta = Math.min(beta, v);
        }
        //System.out.println("value v= " + v + " on ply level "+plyLevel+" returned from end of method in MIN");
        return v;
    }

    // get next state using grantMax randomized algorithm 
    public checkerState grantMax(checkerState currState) { 
        boolean test = false; 
        int rand = 0; 
        checkerState returnState = new checkerState(currState); 
        returnState = getNextStates(returnState); 
       
        Vector children = returnState.getChildren(); 
 
        rand = (int)(Math.random() * children.size()); 
        returnState = (checkerState)children.remove(rand); 
     
        //System.out.println(returnState.getMove()); 
        //System.out.println("GRANT MAX STATE: "); 
        //System.out.println(returnState.toString(flip)); 
        return returnState; 
    } // edn grantMax()
    
    // test if game is over and print out winner
    public boolean gameOver() {
        int count = 0;
        String s = gameState.getPieces();
        for(int i = 1; i < s.length(); i++) {
            if(s.charAt(i) == 'w' || s.charAt(i) == 'W')
                count++;
        }
        if(count == 0) {
            System.out.println("White Wins...BOOOOOO!!!!!");
            System.out.println(gameState.toString(flip));
            return true;
        }
        count = 0;
        for(int i = 1; i < s.length(); i++) {
            if(s.charAt(i) == 'r' || s.charAt(i) == 'R')
                count++;
        }
        if(count == 0) {
            System.out.println("WE WIN!");
            System.out.println("(h!n00|<uMz r0x0rz j00!!!!!!");
            System.out.println(gameState.toString(flip));
            return true;
        }
        return false;
    } // end gameOver()
    
    public boolean isTerminal(checkerState cs, int plyLevel) {
        int count = 0;
        String s = cs.getPieces();
        if(plyLevel >= currPlyLevel)
            return true;
        for(int i = 1; i < s.length(); i++) {
            if(s.charAt(i) == 'w' || s.charAt(i) == 'W')
                count++;
        }
        if(count == 0)
        {
            System.out.println("White Victory State Located! Ply = "+plyLevel);
            return true;
        }
        count = 0;
        for(int i = 1; i < s.length(); i++) {
            if(s.charAt(i) == 'r' || s.charAt(i) == 'R')
                count++;
        }
        if(count == 0)
        {
            System.out.println("Red Victory State Located! Ply = "+plyLevel);
            return true;
        }
        return false;
        
    } // end isTerminal()
    
    // command line input handler
    public String readLine() throws IOException{
        String line = "";
        InputStreamReader isr = new InputStreamReader(System.in);
        BufferedReader input = new BufferedReader(isr);
        
        line = input.readLine();                    
        return line;
    }   // end readLine()
    
    private int totalPieces(checkerState cs)
    {
        return cs.getRedPieces() + cs.getRedKings() + cs.getWhitePieces() + cs.getWhiteKings();
    }

    // detect if there are any jumps on teh board
    private int detectJumpsH(String s, boolean isWhite)
    {
        int count = 0;
        for(int i = 0; i < s.length(); i++)
        {
            if(isWhiteJump(s, i) && isWhite)
                count++;
            else if(isRedJump(s, i) && !isWhite)
                count++;      
        }
        return count;
    } // end detectJumps()

    
    // return heuristic value
    public int getValue(checkerState cs)
    {
        int redPiece = cs.getRedPieces();
        int redKing = cs.getRedKings();
        int whitePiece = cs.getWhitePieces();
        int whiteKings = cs.getWhiteKings();
        int rJump = detectJumpsH(cs.getPieces(), false);
        int wJump = detectJumpsH(cs.getPieces(), true);
        if((redPiece + redKing) == 0) return -100000;
        else if ((redPiece + redKing) == 0) return 100000;
        else if(whiteKings == 0)
         return ((100*redKing) + ((-100*(whitePiece + whiteKings)) + (100*(redPiece + redKing))) + (100*badSqsEmpty(cs)) + (-2*goodSqsEmpty(cs)) + (-250*whiteKings) + (-150*jumpables(cs)) + (100*rJump) + (-200*wJump));
        if(totalRedPieces(cs) < 5)
         return (-500*(whitePiece + whiteKings)) + (500*(redPiece + redKing));
        else
         //return ((100*redKing) + ((-100*(whitePiece + whiteKings)) + (100*(redPiece + redKing))) + (100*badSqsEmpty(cs)) + (-2*goodSqsEmpty(cs)) + (-75*whiteKings) + (-150*jumpables(cs)) + (100*rJump) + (-200*wJump));
          return (-800*redKing) + (-750*(whitePiece + whiteKings) - (redPiece + whiteKings)) + (100*badSqsEmpty(cs)) + (-8*goodSqsEmpty(cs)) + (400*whiteKings);
    } // end getValue()
    
    private int badSqsEmpty(checkerState cs)
    {
        int count = 0;
        if(!flip){
        for(int i=29; i<33; i++)
        {
            if(cs.isClear(i)) count++;
        }}
        else        
        {for(int i=1; i<5; i++)
        {
            if(cs.isClear(i)) count++;
        }}
        return count;
    }
    
    private int goodSqsEmpty(checkerState cs)
    {
        int count = 0;
        if(!flip){
        for(int i=1; i<5; i++)
        {
            if(cs.isClear(i)) count++;
        }}
        else
        {for(int i=29; i<33; i++)
        {
            if(cs.isClear(i)) count++;
        }}
        return count;
    }
    
    private int jumpables(checkerState cs)
    {
        int count = 0;
        String pieces = cs.getPieces();
        for(int i=0; i<pieces.length(); i++)
        {
            if(pieces.charAt(i) == 'w')
            {
                int[] adj = (int[])board.get(i);
                for(int j=0; j<adj.length; j++)
                {
                    if(adj[j]>i && (pieces.charAt(adj[j]) == 'r' || pieces.charAt(adj[j]) == 'R'))
                    {
                        if(adj.length >2)
                        {
                            int z = 0;
                        
                            if(j == 4) z = 1;
                            if(j==3) z = 2;
                        
                            if(cs.isClear(z))
                                count++;                        
                        }
                    }
                }
            }
            else if(pieces.charAt(i) == 'W')
            {
                int[] adj = (int[])board.get(i);
                for(int j=0; j<adj.length; j++)
                {
                    if((pieces.charAt(adj[j]) == 'r' || pieces.charAt(adj[j]) == 'R'))
                    {
                        count++;                        
                    }
                }
            }
        }
        return count;
    }
    
    private int totalRedPieces(checkerState cs)
    {
        return cs.getRedPieces() + cs.getRedKings();
    }
    
} // end class Reds()
