/*
 * Created on Mar 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author Jan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
 

import java.util.*;

public abstract class Agent
{
	//fields
	protected byte side;
	protected int agentID;
	protected int totalScore; //This is the score of how well the agent plays
	protected Node myPreviousNode, myCurrentNode, hisPreviousNode, hisCurrentNode;
	protected Evaluation evalME, evalHIM, evalDELTA; //just to keep the results of evaluation for every evaluation
	protected Moves movesClass;
	protected Weights weights;
	//protected Vector vect;
	
	public Agent(int agentID, Weights weights, Moves movesClass)
	{
		this.agentID = agentID;
		this.movesClass = movesClass;
		this.weights = weights;
		this.totalScore = 0;
		//vect = new Vector(Const.TYPICAL_MOVES);
	}
	
	public void initAgent(byte side)
	{
		this.side = side;
		myCurrentNode = movesClass.initNode();
		hisCurrentNode = movesClass.initNode();
		evalME = new Evaluation(side);
		evalHIM = new Evaluation(Const.opponent(side));
		evalDELTA = new Evaluation();
	}
	
	abstract public String myTurn(Interaction intera);
	
	public void hisTurn(String move, Interaction intera)
	{
		Vector vect = new Vector(Const.TYPICAL_MOVES);
		
		//System.out.println("Agent " + agentID + ": The board before his move looks like this for me:");
		//myCurrentNode.getState().printLabel();
		//myCurrentNode.getState().printBoard();

		if(move != null)
		{
			boolean theresNoMove = movesClass.allPossibleMoves(myCurrentNode, vect, Const.opponent(side));
			if(theresNoMove) //he cant move, he lost
			{
				intera.youLost(Const.opponent(side));
			}
			else //he can move, test if it's move is OK
			{
				hisPreviousNode = hisCurrentNode;
				
				boolean same = false;
				for(Enumeration enum = vect.elements(); enum.hasMoreElements(); ) //choose nextState with smallest value
				{
					Node grabNode = (Node) enum.nextElement();
					if(move.compareTo(grabNode.getMove() ) == 0) //if the boards are the same
					{
						hisCurrentNode = grabNode;
						same = true;
						break;
					} 
				}
								
				if(same)
				{
					System.out.println("Agent " + agentID + ": his move " + move + " is OK.");
				}
				else
					System.out.println("Agent " + agentID + ": his move " + move + " is not a successor state");

			}
			
			//System.out.println("Agent " + agentID + ": The board after his move looks like this for me:");
			//myCurrentNode.getState().printLabel();
			//hisCurrentNode.getState().printBoard();

			vect.removeAllElements(); //clear Vector;
		}
		else System.out.println("This is the opening move.");
	}
	
	public void takeBack()
	{
		myCurrentNode = myPreviousNode;
	}
	
	public void addScore(int addScore)
	{
		totalScore += addScore;
	}
	
	public void setWeights(Weights nweights) { weights = nweights; }
	
	//queries
	public int getScore()
	{
		return totalScore;
	}
	
	public Weights getWeights()
	{
		return weights;
	}
	
	public int getID()
	{
		return agentID;
	}
}