/*
 * Created on Mar 9, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
 

import java.util.*;

/**
 * @author Jan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AgentComputer extends Agent
{
	//other fields
	private long time_limit;
	private long startTime;
	private int depthLimit;
	private long nodesExpanded;
	private boolean onlyOneMove;
	
	//constructor
	public AgentComputer(int agentID, Weights weights, Moves movesClass, long time_limit, int depthLimit)
	{
		super(agentID, weights, movesClass);
		this.time_limit = time_limit;
		this.depthLimit = depthLimit;
	}

	public String myTurn(Interaction intera)
	{
		int d = 0; //depth 0 is root for me
		Node nextBestNode = myCurrentNode;
		Node currentBestNode = myCurrentNode;
		

		startTime = System.currentTimeMillis();
		nodesExpanded = 0;
		
		System.out.println("Let me think...");

		Vector vect = new Vector(Const.TYPICAL_MOVES);

		movesClass.allPossibleMoves(hisCurrentNode, vect, side);
		nodesExpanded++;
		
		System.out.println("Possible moves:");
		for(Enumeration enum = vect.elements(); enum.hasMoreElements(); ) //choose nextState with smallest value
		{
			Node grabNode = (Node) enum.nextElement();
			System.out.println(grabNode.getMove());
		}

		if(vect.isEmpty()) //I cant move, I lost
		{
			intera.youLost(side);
			return null;
		}
		else if(vect.size() == 1) //just one move possible
		{
			myCurrentNode = (Node) vect.elementAt(0); 
			
			System.out.println("Agent " + agentID + ": I have just one move");
			System.out.println("Agent " + agentID + ": My move: " + myCurrentNode.getMove());
			System.out.println("Agent " + agentID + ": The board after my move looks like this for me:");
			myCurrentNode.getState().printBoard();
			
			return myCurrentNode.getMove(); //return the only possible move
		}
		else //I can move and choose the best one
		{
			while(!timeOver())
			{
				currentBestNode = nextBestNode;
				System.out.print("\nID deepening: depth limit = " + d + " process: ");
				nextBestNode = myIDTurn(intera, d);
				d++;
			}
	
			myPreviousNode = myCurrentNode; //i will make a new move 
			myCurrentNode = currentBestNode;
		
			long timeTaken = System.currentTimeMillis() - startTime;
			System.out.println("\nAgent " + agentID + ": Total nodes expanded: " + nodesExpanded + " in " + timeTaken/1000 + "s that gives " + 1000*nodesExpanded/timeTaken + "nodes/s");
			System.out.println("Agent " + agentID + ": My move: " + myCurrentNode.getMove());
			System.out.println("Agent " + agentID + ": The board after my move looks like this for me:");
			myCurrentNode.getState().printBoard();
			return myCurrentNode.getMove();
		}
	}

	private Node myIDTurn(Interaction intera, int depth_limit) 		//I am MAX
	{
		Vector vect = new Vector(Const.TYPICAL_MOVES);

		depthLimit = depth_limit;
		String move = null;
		movesClass.allPossibleMoves(hisCurrentNode, vect, side);
		nodesExpanded++;
		
		int rootExp = 0;
		int rootTotal = vect.size();

		long alpha = -Const.INFINITY;
		long beta = Const.INFINITY;
		int depth = 0;
		long highestUtility = -Const.INFINITY;
			
		long utility;
		Node highestNode = myCurrentNode; //we have some successors, so just to put there something
		for(int i = 0; i < vect.size(); i++) //choose nextState with smallest value
		{				
			Node grab = (Node) vect.elementAt(i);
			utility = minValue(grab, alpha, beta, depth + 1);
				rootExp++;
				System.out.print(100 * rootExp/(rootTotal) + "% ");
			if(utility > highestUtility)
			{
				highestNode = grab;
				highestUtility = utility; 
			}
		}
			
		//vect.removeAllElements(); //clear Vector;
		return highestNode; //returns null if I lost, otherwise return String				
	}
	
	private long maxValue(Node node, long alpha, long beta, int depth)
	{
		Vector vect = new Vector(Const.TYPICAL_MOVES);
		
		movesClass.allPossibleMoves(node, vect, side);
		nodesExpanded++;
		
		if(vect.isEmpty()) //I cant move, I lost
		{
			return +Const.INFINITY; //to loose is my goal
		}
		else //I can move, choose the best move
		{

			Node grab;
			long highestUtility = -Const.INFINITY;
			
			if(depth > depthLimit /*&& quiescent(node) )*/ ) return eval(node); //quiescence test overflows the stack
			
			//this slows things down
			//highestEvalOnBottom(vect); //we will start with possibly best move allowing good pruning
			
			long utility;
			for(int i = 0; i < vect.size(); i++) //choose nextState with smallest value
			{
				if(!timeOver())
				{
					grab = (Node) vect.elementAt(i);
					utility = minValue(grab, alpha, beta, depth + 1);
				
					if(utility > highestUtility) highestUtility = utility;
				
					if(highestUtility >= beta)
					{
						//vect.removeAllElements(); //clear Vector; not necessary
						return highestUtility; //prune the rest
					}
			
					if(highestUtility > alpha) alpha = highestUtility;
				}
				else return 0; //time is over and the tree wasnt explored to given depthLimit, so return whatever, wont ve considered
			}
			
			//vect.removeAllElements(); //clear Vector; not necessary
			return highestUtility;		
		}		
	}
	
	//OPPONENT is MIN
	private long minValue(Node node, long alpha, long beta, int depth)
	{
		Vector vect = new Vector(Const.TYPICAL_MOVES);
		
		movesClass.allPossibleMoves(node, vect, Const.opponent(side));
		nodesExpanded++;
		if(vect.isEmpty()) //He cant move, he lost
		{
			return -Const.INFINITY; //too bad, to win is not my goal
		}
		else //He can move, he will choose the best move for him
		{
			Node grab;
			long lowestUtility = +Const.INFINITY;
			
			if(depth > depthLimit /*&& quiescent(node)*/ ) return eval(node); //quiescence test overflows stack
			
			//this slows things down
			//lowestEvalOnBottom(vect); //we will start with possibly best move allowing good pruning
				
			long utility;
			for(int i = 0; i < vect.size(); i++) //choose nextState with smallest value
			{
				if(!timeOver())
				{
					grab = (Node) vect.elementAt(i);
					utility = maxValue(grab, alpha, beta, depth + 1);
				
					if(utility < lowestUtility) lowestUtility = utility;
				
					if(lowestUtility <= alpha)
					{
						//vect.removeAllElements(); //clear Vector; not necessary
						return lowestUtility; //prune the rest
					}
			
					if(lowestUtility < beta) beta = lowestUtility;
				}
				else return 0; //just jump out, this tree wont be considered anyway
			}
			
			//vect.removeAllElements(); //clear Vector; not necessary
			return lowestUtility;		
		}		
	}


	private void highestEvalOnBottom(Vector vect)
	{		
		int iHighestUtility = 0;
		Node grab = (Node) vect.elementAt(iHighestUtility);
		Node highestNode = grab;
		long highestUtility = eval(grab);
		
		long utility;
		for(int i = 1; i < vect.size(); i++) //choose nextState with smallest value
		{
			grab = (Node) vect.elementAt(i);
			utility = eval(grab);
			if(utility > highestUtility)
			{
				highestUtility = utility;
				highestNode = grab;
				iHighestUtility = i; 
			}
		}
		
		vect.removeElementAt(iHighestUtility); //remove it from where it was
		vect.insertElementAt(highestNode, 0); //and put in on the bottom
	}

	private void lowestEvalOnBottom(Vector vect)
	{
		int iLowestUtility = 0;
		Node grab = (Node) vect.elementAt(iLowestUtility);		
		Node lowestNode = grab;
		long lowestUtility = eval(grab);
		
		long utility;
		for(int i = 1; i < vect.size(); i++) //choose nextState with smallest value
		{
			grab = (Node) vect.elementAt(i);
			utility = eval(grab);
			if(utility < lowestUtility)
			{
				lowestUtility = utility;
				lowestNode = grab;
				iLowestUtility = i;
			}
		}
		
		vect.removeElementAt(iLowestUtility); //remove it from where it was
		vect.insertElementAt(lowestNode, 0); //and in on the bottom
	}
	
	private long eval(Node node) //returns value of the state in the node 
	{
		evalME.evaluate(node);
		evalHIM.evaluate(node);
		//this is "static" deltaEvaluation
		evalDELTA.deltaEvaluation(evalHIM, evalME, evalDELTA); //evalHIM - evalME = evalDELTA because we want to loose
		long evaluation = evalDELTA.getCheckers() * weights.getCheckers() +
							evalDELTA.getKings() * weights.getKings() +
							evalDELTA.getMobility() * weights.getMobility() +
							evalDELTA.getExch() * weights.getExch() +
							evalDELTA.getkCent() * weights.getkCent() +
							evalDELTA.getFrontRank() * weights.getFrontRank() +
							evalDELTA.getGuard() * weights.getGuard();		
		node.setEvaluation(evaluation);
		return evaluation;
		//return 0;
	}
	
	private boolean quiescent(Node node)
	{
		State currentState = node.getState();
		return evalDELTA.quiescent(currentState, Const.booleanPlayer(Const.UP)) && evalDELTA.quiescent(currentState, Const.booleanPlayer(Const.DOWN));
	}
	
	private boolean timeOver()
	{
		long currentTime = System.currentTimeMillis();
		if((currentTime - startTime) > time_limit) return true;
		else return false;
	}
}