/*
 * Created on Mar 11, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
 

import java.util.*;

/**
 * @author Jan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Genetics
{
	//fields
	private Agent []member;
	private double mutRatio;
	private Game game;
	private Random rnd;
	private int popSize;
	
	//constructor
	public Genetics(Agent []member, Game game, double mutRatio) //the population size has to be even!!!
	{
		this.member = member;
		this.game = game;
		this.mutRatio = mutRatio;
		rnd = new Random();
		popSize = member.length;
		if(popSize % 2 == 1) System.out.println("Population size is not even!! Will cause errors!");
	}
	
	//methods
	public void evolution(int cycles)
	{
		int age = 0;
		do
		{
			matchup();
			selection();
			crossover();
			mutation();
		}
		while(age < cycles);
		
		//printout weights of successful agents
		printWeights();		
	}
	
	private void matchup()
	{
		int indexing = 0;
		
		while(indexing < popSize)
		{
			Agent oneMember = member[indexing];
			indexing++; 
			Agent otherMember = member[indexing];
			indexing++;
			
			game.RegisterDOWN(oneMember);
			game.RegisterUP(otherMember);
			game.StartGame(Const.DOWN); //somebody might win and get its score updated
		}
		
	}
	
	private void selection()
	{
		//select next full generation by its fitness function
		Agent []nextMember = new Agent[popSize];
		System.out.println("Selection phase of the genetic algorithm:");
		
		int fitnessTogether = 0;
		for(int i = 0; i < popSize; i++) fitnessTogether += member[i].getScore();
			
		int newPopSize = 0;
		
		while(newPopSize < popSize)
		{
			double rn = rnd.nextDouble();
			int index = rnd.nextInt(popSize);
			
			double fp = member[index].getScore() / fitnessTogether;
			if(fp < rn)
			{
				nextMember[newPopSize] = member[index];
				newPopSize++;
				System.out.println("Agent " + member[index].getID() + ", fitness percentage: " + (int) (100 * fp) + "% was chosen as a next generation member");
			} 
		}
		
		member = nextMember; //update the parent generation
	}
	
	private void crossover()
	{
		//change one entry in each agents weights vector;
		int indexing = 0;
		
		while(indexing < popSize)
		{
			Agent oneMember = member[indexing];
			Weights oneWeights = oneMember.getWeights();
			indexing++; 
			Agent otherMember = member[indexing];
			Weights otherWeights = otherMember.getWeights();
			indexing++;
			
			int which = rnd.nextInt(Const.HEUR); 
			oneWeights.exchangeWeight(otherWeights, which);
		
		}
	}
	
	private void mutation()
	{
		for(int i = 0; i < popSize; i++) 
		{
			int which = rnd.nextInt(Const.HEUR); 
			double mutationRatio = rnd.nextDouble(); //(0, 1)
			mutationRatio -= mutationRatio / 2; //(-.5, .5)
			mutationRatio *= mutRatio;  //mutRatio (0, 1)
			Weights weights = member[i].getWeights();
			
			weights.muteWeight(mutationRatio, which);	
		}
		
	}
	
	private void printWeights()
	{
		for(int i = 0; i < popSize; i++)
		{
			System.out.println("Agent " + member[i].getID());
			member[i].getWeights().printWeights();
		} 

	}
}
