 

public class State {
	protected int[] data;
	protected boolean turnWhite;
	public Stack moves;
	public static final boolean STOP_KING = true;
	public boolean kinged;
	//public boolean areKings=false;
	
	//properties for the search
	//protected int[] minmax = new int[2]; //generic alpha beta 0 is best for black 1 is best for white
	/* fun part for non-rec minmax
	protected int floor=Integer.MIN_VALUE;
	protected int ceiling=Integer.MAX_VALUE;
	protected int depth;
	protected Stack successors;
	protected State parent;
	protected State bestChild;
	protected int v;
	protected boolean expanded=false;
	protected boolean playsMax;
	*/
	public State() {
		data = new int[3];
		turnWhite = false;
		moves = new Stack();
		kinged = false;
		

	}
	public boolean getData(int a, int b) {
		return (((data[b] >> a) & 1) == 1);
	}

	public void setData(int a, int b, boolean v) {
		if (v) {
			data[b] |= (1 << a);
		} else {
			data[b] &= (~(1 << a));
		}
	}

	public void initial() {
		data[0] = -1044481; //true for a checker
		data[1] = -1048576; //true for white
		data[2] = -1044481; //true for man
		
		
		//data[0]=2197522;
		//data[1]=-863466294;
		//data[2]=-863111307;
		/*
		data[0]=539754880;
		data[1]=-863187254;
		data[2]=-846121547;
		*/
		
		/*
		data[0] =-1906310872;
		data[1] =-67431126;
		data[2] =-787467;
		
			
		data[0] = 4723058;
		data[1] = -342163456;
		data[2] = -270536705;
		
		turnWhite=true;
		
		data[0] =-121634542;
		data[1] =-882380;
		data[2] =-4757509;*/
	/*	
		data[0] = -533717496;
	    data[1] = -4849568;
		data[2] = -589825;
	
	data[0] =88351744;
	data[1] =-9296988;
	data[2] =-524421;*/

	}

	public State copy() {
		State s = new State();

		/*
		for (int j = 0; j < 3; j++) {
			s.data[j] = data[j];
		}
		*/
		s.data[0]=data[0];
		s.data[1]=data[1];
		s.data[2]=data[2];
		
		s.turnWhite = turnWhite;
		return s;
	}
	public String getPosition(int i) {
		String res;
		if (getData(i, 0))
			if (getData(i, 1))
				if (getData(i, 2) )
					res = "_mW_|";
				else
					res = "_kW_|";
			else if (getData(i, 2))
				res = "_mB_|";
			else
				res = "_kB_|";
		else
			res = "____|";

		return res;
	}

	public String toString() {
		int k = 0;
		String res = "";
		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 8; j++) {
				if ((i + j) % 2 == 0)
					res = res + "____|";
				else {
					res = res + getPosition(k);
					k++;

				}
			}
			res = res + "\n";
		}
		return res;
	}

	public static int moveA(int pos) {
		int ret = -1;
		int m;
		if (pos < 28) {
			m = pos & 7;
			if (m < 4)
				ret = pos + 4;
			if (m > 4)
				ret = pos + 3;
		}
		if (ret < 0)
			ret = -1;
		return ret;
	}

	public static int moveB(int pos) {
		int ret = -1;
		int m;
		if (pos < 27) {
			m = pos & 7;
			if (m < 3)
				ret = pos + 5;
			if (m > 3)
				ret = pos + 4;
		}
		if (ret < 0)
			ret = -1;
		return ret;
	}

	public static int moveC(int pos) {
		int ret = -1;
		int m;
		if (pos > 4) {
			m = pos & 7;
			if (m < 4)
				ret = pos - 4;
			if (m > 4)
				ret = pos - 5;
		}
		if (ret < 0)
			ret = -1;
		return ret;
	}

	public static int moveD(int pos) {
		int ret = -1;
		int m;
		if (pos > 3) {
			m = pos & 7;
			if (m < 3)
				ret = pos - 3;
			if (m > 3)
				ret = pos - 4;
		}
		if (ret < 0)
			ret = -1;
		return ret;
	}

	public static int forwardLeft(int pos, boolean col) {
		return (col)?moveC(pos):moveA(pos);
		
	}
	public static int forwardRight(int pos, boolean col) {
		return (col)?moveD(pos):moveB(pos);
		
	}

	public static int backwardLeft(int pos, boolean col) {
		return (col)?moveA(pos):moveC(pos);
		
	}
	public static int backwardRight(int pos, boolean col) {
		return (col)?moveB(pos):moveD(pos);
		
	}

	public Stack genAllSuccessors() {
		Stack states = generateAllJumps();
		int z;
		if (states.isEmpty()) {

			for (int pos = 0; pos < 32; pos++)
				if (getData(pos, 0) && getData(pos, 1) == turnWhite) {
					z = forwardLeft(pos, turnWhite);
					if ((z != -1) && !(getData(z, 0)))
						states.push(genASuccessor(pos, z, pos));

					z = forwardRight(pos, turnWhite);
					if ((z != -1) && !(getData(z, 0)))
						states.push(genASuccessor(pos, z, pos));

					if (!(getData(pos, 2))) { // checking for king
						z = backwardLeft(pos, turnWhite);
						if ((z != -1) && !(getData(z, 0)))
							states.push(genASuccessor(pos, z, pos));

						z = backwardRight(pos, turnWhite);
						if ((z != -1) && !(getData(z, 0)))
							states.push(genASuccessor(pos, z, pos));
					}
				}
		}

		return states;
	}

	public State genASuccessor(int pos, int newPos, int remPos) {
		State st = new State();

		st.data[0]=data[0];
		st.data[1]=data[1];
		st.data[2]=data[2];
		
		/*		
		for (int j = 0; j < 3; j++) {
			st.data[j] = data[j];
		}
		*/
		
		st.setData(pos, 0, false);
		st.turnWhite = !turnWhite;

		st.setData(newPos, 0, true);
		st.setData(newPos, 1, getData(pos, 1));
		st.setData(newPos, 2, getData(pos, 2));

		if ((st.getData(newPos, 1) && newPos < 4)
			|| (!st.getData(newPos, 1) && newPos > 27))
			st.setData(newPos, 2, false);
		st.kinged = st.getData(newPos, 2) != getData(pos, 2);
		//st.areKings=(areKings||st.kinged);
		
		st.setData(remPos, 0, false);

		if (moves.isEmpty())
			st.moves.push(new Integer(pos));
		else
			st.moves.top = moves.top;

		st.moves.push(new Integer(newPos));
		return st;
	}

	public boolean generateJumps(int pos, Stack s) {
		boolean jump = false;

		boolean col = getData(pos, 1);
		int z = forwardLeft(pos, col);
		if (z != -1) {
			int zz = forwardLeft(z, col);
			if (zz != -1)
				if ((getData(z, 0))
					&& (getData(z, 1) != col)
					&& !(getData(zz, 0))) {
					s.push(genASuccessor(pos, zz, z));
					jump = true;
				}
		}
		z = forwardRight(pos, col);
		if (z != -1) {
			int zz = forwardRight(z, col);
			if (zz != -1)
				if ((getData(z, 0))
					&& (getData(z, 1) != col)
					&& !(getData(zz, 0))) {
					s.push(genASuccessor(pos, zz, z));
					jump = true;
				}
		}
		if (!(getData(pos, 2))) { // checking for king
			z = backwardLeft(pos, col);
			if (z != -1) {
				int zz = backwardLeft(z, col);
				if (zz != -1)
					if ((getData(z, 0))
						&& (getData(z, 1) != col)
						&& !(getData(zz, 0))) {
						s.push(genASuccessor(pos, zz, z));
						jump = true;
					}
			}
			z = backwardRight(pos, col);
			if (z != -1) {
				int zz = backwardRight(z, col);
				if (zz != -1)
					if ((getData(z, 0))
						&& (getData(z, 1) != col)
						&& !(getData(zz, 0))) {
						s.push(genASuccessor(pos, zz, z));
						jump = true;
					}

			}
		}
		return jump;
	}

	public Stack generateAllJumps() {
		Stack s = new Stack();
		Stack succ = new Stack();
		for (int i = 0; i < 32; i++) {
			if (getData(i, 0) && getData(i, 1) == turnWhite)
				generateJumps(i, s);
		}

		State aux;
		while (!s.isEmpty()) {
			aux = (State) s.pop();
			if (STOP_KING && aux.kinged) {
				aux.kinged = false;
				aux.turnWhite = !turnWhite;
				succ.push(aux);
			} else if (
				!(aux
					.generateJumps(
						((Integer) aux.moves.top()).intValue(),
						s))) {

				aux.turnWhite = !turnWhite;
				succ.push(aux);
			}

		}
		return succ;
	}

	public String printMoves() {
		String s = "";
		while (!(moves.isEmpty())) {
			if (s == "")
				s = s + (((Integer) moves.pop()).intValue() + 1);
			else
				s = (((Integer) moves.pop()).intValue() + 1) + "-" + s;
		}
		return s;
	}

    public int numOfPieces(boolean b){
    	int i=0;
    	for (int j=0;j<32;j++){
    		if (getData(j,0)&&getData(j,1)==b) i++;
    	}
    	return i;
    }
	public boolean Move(String t) {
		int[] movesArray = new int[13];
		for (int i = 0; i < 13; i++) {
			movesArray[i] = -1;
		}
		try {

			int poss = 0;
			int i = 0;
			int numstart = 0;
			String ttt;
			while (i < t.length()) {
				while (i < t.length() && t.charAt(i) != '-') {
					i++;
				}
				ttt = t.substring(numstart, i);
				movesArray[poss] =
					Integer.decode(t.substring(numstart, i)).intValue() - 1;
				//-1 converts to 0-31 array representation
				i++;
				numstart = i;
				poss++;
			}

			i = 1;
			int pos = movesArray[0];
			int newPos = -1;
			int remPos = -1;
			int dif;
			int tmpmove;

			while (movesArray[i] != -1) {
				dif = movesArray[i] - movesArray[i - 1];
				pos = movesArray[i - 1];
				newPos = movesArray[i];
				if (Math.abs(dif) > 5) {
					if (dif < 0) {
						tmpmove = moveC(movesArray[i - 1]);
						if ((tmpmove) >= 0) {
							if (moveC(tmpmove) == movesArray[i]) {
								remPos = tmpmove;
							}
						}
						tmpmove = moveD(movesArray[i - 1]);
						if ((tmpmove) >= 0) {
							if (moveD(tmpmove) == movesArray[i]) {
								remPos = tmpmove;
							}
						}
					} else {
						tmpmove = moveA(movesArray[i - 1]);
						if ((tmpmove) >= 0) {
							if (moveA(tmpmove) == movesArray[i]) {
								remPos = tmpmove;
							}
						}
						tmpmove = moveB(movesArray[i - 1]);
						if ((tmpmove) >= 0) {
							if (moveB(tmpmove) == movesArray[i]) {
								remPos = tmpmove;
							}
						}
					}
				} else {
					remPos = pos;
				}

				setData(pos, 0, false);
				kinged = false;

				setData(newPos, 0, true);
				setData(newPos, 1, getData(pos, 1));
				setData(newPos, 2, getData(pos, 2));

				if ((getData(newPos, 1) && newPos < 4)
					|| (!getData(newPos, 1) && newPos > 27))
					setData(newPos, 2, false);

				setData(remPos, 0, false);

				i++;

			}
			turnWhite = !turnWhite;
			return true;
		} catch (Exception e) {

			e.printStackTrace();
			return false;
		}
	} 
	
	public int hashCode(){
		//return toString().hashCode();
		return ((data[0] & data[1])|(data[0] & ~data[1]));
	}
	
	public boolean equals(Object st){
	State s=(State) st;	
	return ((turnWhite==s.turnWhite)&&(data[0] & data[1])== (s.data[0] & s.data[1]))&&((data[0] & ~data[1])== (s.data[0] & ~s.data[1]))&&((data[0] & data[2])== (s.data[0] & s.data[2]));
		
	}
		
}
