/*
 * Created on Mar 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

/**
 * @author cslabuser
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class CInterface {

JTextArea Board = new JTextArea(8, 22);
JTextField txtNewMove = new JTextField(22);
JTextArea txtInfo = new JTextArea(3, 16);
JButton	btnUndo = new JButton("Undo");
JTextArea lstMoves = new JTextArea(20, 16);
JScrollPane ScrollPane = new JScrollPane(lstMoves, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

// We used this declaration for the undo function
CBoard 	cCurrent;
CBoard 	cPrevious;

boolean CanUndo = false;

boolean BlackIsHuman;
boolean WhiteIsHuman;

CAI Agent;

public CInterface(CBoard cBoard, boolean iBlackIsHuman, boolean iWhiteIsHuman, CAI iAgent) {

		cCurrent = cBoard;
		
		BlackIsHuman = iBlackIsHuman;
		WhiteIsHuman = iWhiteIsHuman;
		
		Agent = iAgent;
		
		/*
		 *  DEFINE THE INTERFACE
		 */
		
		try { UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); }
		catch(Exception e) {}
		
		final JFrame Window = new JFrame("Ll");
		
		Window.getContentPane().setLayout(null);
		
		/* Create menu */
		JMenuBar MenuBar = new JMenuBar();
		JMenu mnuGame = new JMenu("Game");
		JMenu mnuAbout = new JMenu("About");
		
		/* Create menu items */
		mnuGame.add(makeMenuItem("New", 'n', "alt N", true, new ActionListener()
		{  public void actionPerformed(ActionEvent evt)
		   {
		   /* Create a new game */
		   }
		}));		
		
		mnuGame.add(makeMenuItem("Exit", 'x', "alt F4", true, new ActionListener()
		{  public void actionPerformed(ActionEvent evt)
		   {
			  System.exit(0);
		   }
		}));
		
		/* Add MenuBar and Menu to the Window*/
		mnuGame.setMnemonic('G');
		mnuAbout.setMnemonic('A');
		MenuBar.add(mnuGame);
		MenuBar.add(mnuAbout);
		Window.setJMenuBar(MenuBar);
		
		/* Board properties */
		Board.setEditable(false);
		Board.setFont(new Font("Courier", Font.PLAIN, 14));
		Board.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY));
		RedrawBoard();
		Window.getContentPane().add(Board);
		
		/* Input for new move */
		txtNewMove.setFont(new Font("Courier", Font.PLAIN, 14));
		Window.getContentPane().add(txtNewMove);
		
		/*
		 * What happends when the player (human) plays
		 */
		txtNewMove.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) { //onEnter
				boolean GameOver = false;
				btnUndo.setEnabled(CanUndo);
				
				// Make a copy of the last move so we can undo it
				cPrevious = cCurrent.Clone();
		
				int iResult = cCurrent.MakeMove(txtNewMove.getText(), true);
					
				if(iResult == -1) {
					txtNewMove.setText("Invalid move.");
					System.out.println("Move not valid (" + txtNewMove.getText());
					return;
				}
				else if (iResult == 1)
					System.out.println("Move processed");
				else if (iResult == 2)
				{
					System.out.println("Game over, one side has no more pieces.");
					GameOver = true;
				}
				CanUndo = true;
				
				PrintMove(txtNewMove.getText());
				UpdateInfo();
				
				RedrawBoard();
				txtNewMove.setText("");
				Window.repaint();
				
				if(cCurrent.TheGameIsOver() != cCurrent.NO)
				{
					System.out.println("Interface. Game over, No more possible moves.");
					GameOver = true;
				}
				
				//cCurrent.SwitchTurn();
				
				if ((!BlackIsHuman || !WhiteIsHuman) && !GameOver) {
					
					txtNewMove.setEditable(false);
					btnUndo.setEnabled(false);
					
					PrintMove(Agent.Play(cCurrent));
					//cCurrent.SwitchTurn();
					RedrawBoard();
					UpdateInfo();
				
					txtNewMove.setEditable(true);
					btnUndo.setEnabled(CanUndo);
				
				}

				// If game over, disable everything so we have to start a new game to play again				
				if(GameOver)
				{
					txtNewMove.setEditable(false);
					btnUndo.setEnabled(false);
				}
				
				UpdateInfo();
							
			}
		});

		// Add the Undo button
		Window.getContentPane().add(btnUndo);
			
		btnUndo.addActionListener( new ActionListener(){
			public void actionPerformed(ActionEvent e){
				cCurrent = cPrevious;
				
				// Display Whose turn it is
				cCurrent.printWhoseTurnItIs();
				PrintMove("-- Move canceled --");
				RedrawBoard();
				txtNewMove.setText("");
				CanUndo = false;
				btnUndo.setEnabled(false);
			}		
		});
		
		/* Info textbox */
		txtInfo.setForeground(Color.WHITE);
		txtInfo.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY));
		txtInfo.setBackground(Color.GRAY);
		txtInfo.setEditable(false);
		Window.getContentPane().add(txtInfo);
				
		/*  */
		lstMoves.setEditable(false);
		Window.getContentPane().add(ScrollPane);		
				
		/* set position of gui items */		
		Insets insets = Window.getContentPane().getInsets();
		
		Dimension size = Board.getPreferredSize();
		Board.setBounds(10 + insets.left, 10 + insets.top, size.width, size.height);
		
		size = txtNewMove.getPreferredSize();
		txtNewMove.setBounds(10 + insets.left, 260 + insets.top, size.width, size.height);

		size = txtInfo.getPreferredSize();
		txtInfo.setBounds(10 + insets.left, 200 + insets.top, size.width, size.height);

		size = ScrollPane.getPreferredSize();
		ScrollPane.setBounds(200 + insets.left, 10 + insets.top, size.width, size.height);


		// First, the button must be disable so we cannot undo the 1st move
		btnUndo.setEnabled(false);
		
		size = btnUndo.getPreferredSize();
		btnUndo.setBounds(10 + insets.left, 290 + insets.top, size.width, size.height);
	
		Window.setSize(400, 400);
		Window.show();
		
	}

	public void UpdateInfo() {
		
		if ( (cCurrent.TheGameIsOver() != cCurrent.NO) && cCurrent.isBlacksMove())
			txtInfo.setText("White won.");
		if ( (cCurrent.TheGameIsOver() != cCurrent.NO) && !cCurrent.isBlacksMove())
			txtInfo.setText("Black won.");
		else if (cCurrent.isBlacksMove() && BlackIsHuman)
			txtInfo.setText("Black's Move [human]\n\nEnter your move:");
		else if (cCurrent.isBlacksMove() && !BlackIsHuman)
			txtInfo.setText("Black's Move [agent]\n\nWait please.");
		else if (!cCurrent.isBlacksMove() && WhiteIsHuman)
			txtInfo.setText("White's Move [human]\n\nEnter your move:");
		else if (!cCurrent.isBlacksMove() && !WhiteIsHuman)
			txtInfo.setText("White's Move [agent]\n\nWait please.");
				
	}
	
	public void PrintMove (String Move) {
		
		int pos = lstMoves.getCaretPosition();
		lstMoves.append((pos > 0 ? "\n" : "") + (cCurrent.isBlacksMove() ? "White's Move: " : "Black's Move: ") + Move);
		lstMoves.setCaretPosition(pos + Move.length() + (pos > 0 ? 1 : 0));
				
	}
			
	public void RedrawBoard(/*CBoard cBoard*/) {
		Board.setText(cCurrent.Display());
	}
	
	/* Menu Item handling */
	private static JMenuItem makeMenuItem(String name, char mnemonic,
										  String accelerator, boolean active,
										  ActionListener listener)
	{
	   JMenuItem result = new JMenuItem(name);

	   result.setMnemonic(mnemonic);
	   result.setAccelerator(KeyStroke.getKeyStroke(accelerator));
	   result.setEnabled(active);
	   result.addActionListener(listener);

	   return result;
	}
}
