
/**
 * Write a description of class CheckersAgent here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

import javax.swing.*;

public class CheckersAgent
{
    /*** Instance Variables ***/
    private CheckerBoard board;
    private boolean first;                          // do we go first?
    public Tree decisionTree;
    public int treeLevel;
    public TreeNode parentNode;
    public long startTime, endTime;
    public TreeNode undoNode;
    public int numberOfMoves;
    
    /*** Constructors ***/
    public CheckersAgent(boolean go)
    {
        first = go;
        Checker[][] initialBoard = new Checker[8][8];
        for (int i = 0; i < 8; i++)
        {
            for (int j = 0; j < 3; j++)
            {
                if ((j%2 != 0 || i%2 !=0) && (j%2 != 1 || i%2 != 1))
                {
                    initialBoard[i][j] = new Checker(true, false);
                }
                else
                {
                    initialBoard[i][j] = new Checker(false, false);
                }
            }
        }
        for (int i = 0; i < 8; i++)
        {
            for (int j = 3; j < 5; j++)
            {
                initialBoard[i][j] = new Checker(false, false);
            }
        }
        for (int i = 0; i < 8; i++)
        {
            for (int j = 5; j < 8; j++)
            {
                if ((j%2 != 0 || i%2 !=0) && (j%2 != 1 || i%2 != 1))
                {
                    initialBoard[i][j] = new Checker(false, true);
                }
                else
                {
                    initialBoard[i][j] = new Checker(false, false);
                }
            }
        }
        board = new CheckerBoard(initialBoard);
        TreeNode newNode = new TreeNode(board);
        decisionTree = new Tree(newNode);
        numberOfMoves = 0;
    }
    
    /*** Instance Methods ***/
    public void initialAttacks(int startX, int startY, int endX, int endY)
    {
        //CheckerBoard tempBoard = board;
        //Stack initialStack = new Stack();
        //initialStack.push(board);
        //board.beginningX = endX-1;
        //board.beginningY = endY-1;
        if (parentNode.entry.boundary(endX-1, endY-1, endX+1, endY+1) && parentNode.entry.playingBoard[endX-1][endY-1].red == true && parentNode.entry.playingBoard[endX+1][endY+1].empty == true)
        {
            //Checker[][] tempBoard = board.copy(board.playingBoard);
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX-1;
            tempBoard.beginningY = endY-1;
            tempBoard = tempBoard.singleMove(endX-1, endY-1, endX+1, endY+1);
            tempBoard.attack(endX+1, endY+1, parentNode);
        }
        if (parentNode.entry.boundary(endX+1, endY-1, endX-1, endY+1) && parentNode.entry.playingBoard[endX+1][endY-1].red == true && parentNode.entry.playingBoard[endX-1][endY+1].empty == true)
        {
            //CheckerBoard tempBoard = board.copy(board);
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX+1;
            tempBoard.beginningY = endY-1;
            tempBoard = tempBoard.singleMove(endX+1, endY-1, endX-1, endY+1);
            tempBoard.attack(endX-1, endY+1, parentNode);
        }
        if (parentNode.entry.boundary(startX-2, startY-2, startX, startY) && parentNode.entry.playingBoard[startX-1][startY-1].black == true && parentNode.entry.playingBoard[startX-2][startY-2].red == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = startX-2;
            tempBoard.beginningY = startY-2;
            //Adjusted by Mark on 3-7-04 at 2PM
            tempBoard = tempBoard.singleMove(startX-2, startY-2, startX, startY);
            tempBoard.attack(startX, startY, parentNode);
        }
        if (parentNode.entry.boundary(startX+2, startY-2, startX, startY) && parentNode.entry.playingBoard[startX+1][startY-1].black == true && parentNode.entry.playingBoard[startX+2][startY-2].red == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = startX+1;
            tempBoard.beginningY = startY-1;
            tempBoard = tempBoard.singleMove(startX+2, startY-2, startX, startY);
            tempBoard.attack(startX, startY, parentNode);
            //end 3-7-04 2PM adjustment
        }
        //Added by Mark on 3-7-04 at 1:30PM
        if (parentNode.entry.boundary(endX-1, endY+1, endX+1, endY-1) && parentNode.entry.playingBoard[endX-1][endY+1].red == true && parentNode.entry.playingBoard[endX-1][endY+1].king == true && parentNode.entry.playingBoard[endX+1][endY-1].empty == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX-1;
            tempBoard.beginningY = endY+1;
            tempBoard = tempBoard.singleMove(endX-1, endY+1, endX+1, endY-1);
            tempBoard.attackKing(endX+1, endY-1, parentNode);
        }
        if (parentNode.entry.boundary(endX+1, endY+1, endX-1, endY-1) && parentNode.entry.playingBoard[endX+1][endY+1].red == true && parentNode.entry.playingBoard[endX+1][endY+1].king == true && parentNode.entry.playingBoard[endX-1][endY-1].empty == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX+1;
            tempBoard.beginningY = endY+1;
            tempBoard = tempBoard.singleMove(endX+1, endY+1, endX-1, endY-1);
            tempBoard.attackKing(endX-1, endY-1, parentNode);
        }
        if (parentNode.entry.boundary(startX-2, startY+2, startX, startY) && parentNode.entry.playingBoard[startX-2][startY+2].red == true && parentNode.entry.playingBoard[startX-2][startY+2].king == true && parentNode.entry.playingBoard[startX-1][startY+1].black == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = startX-2;
            tempBoard.beginningY = startY+2;
            tempBoard = tempBoard.singleMove(startX-2, startY+2, startX, startY);
            tempBoard.attackKing(startX, startY, parentNode);
        }
        if (parentNode.entry.boundary(startX+2, startY+2, startX, startY) && parentNode.entry.playingBoard[startX+2][startY+2].red == true && parentNode.entry.playingBoard[startX+2][startY+2].king == true && parentNode.entry.playingBoard[startX+1][startY+1].black == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX+2;
            tempBoard.beginningY = endY+2;
            tempBoard = tempBoard.singleMove(startX-2, startY+2, startX, startY);
            tempBoard.attackKing(startX, startY, parentNode);
        }
        //End 3-7-04 1:30PM addition, although this is mirrored in the BlackInitialAttack method
    }
    
    
    public void BlackInitialAttacks(int startX, int startY, int endX, int endY)
    {
        //CheckerBoard tempBoard = board;
        //Stack initialStack = new Stack();
        //initialStack.push(board);
        if (parentNode.entry.boundary(endX+1, endY+1, endX-1, endY-1) && parentNode.entry.playingBoard[endX+1][endY+1].black == true && parentNode.entry.playingBoard[endX-1][endY-1].empty == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX+1;
            tempBoard.beginningY = endY+1;
            tempBoard = tempBoard.singleMove(endX+1, endY+1, endX-1, endY-1);
            tempBoard.attackBlack(endX-1, endY-1, parentNode);
        }
        if (parentNode.entry.boundary(endX-1, endY+1, endX+1, endY-1) && parentNode.entry.playingBoard[endX-1][endY+1].black == true && parentNode.entry.playingBoard[endX+1][endY-1].empty == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX-1;
            tempBoard.beginningY = endY+1;
            tempBoard = tempBoard.singleMove(endX-1, endY+1, endX+1, endY-1);
            tempBoard.attackBlack(endX+1, endY-1, parentNode);
        }
        if (parentNode.entry.boundary(startX+2, startY+2, startX, startY) && parentNode.entry.playingBoard[startX+1][startY+1].red == true && parentNode.entry.playingBoard[startX+2][startY+2].black == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX+2;
            tempBoard.beginningY = endY+2;
            tempBoard = tempBoard.singleMove(startX+2, startY+2, startX, startY);
            tempBoard.attackBlack(startX, startY, parentNode);
        }
        if (parentNode.entry.boundary(startX-2, startY+2, startX, startY) && parentNode.entry.playingBoard[startX-1][startY+1].red == true && parentNode.entry.playingBoard[startX-2][startY+2].black == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = startX-2;
            tempBoard.beginningY = startY+2;
            tempBoard = tempBoard.singleMove(startX-2, startY+2, startX, startY);
            tempBoard.attackBlack(startX, startY, parentNode);
        }
        //Added by Mark on 3-7-04 at 1:30PM
        if (parentNode.entry.boundary(endX+1, endY-1, endX-1, endY+1) && parentNode.entry.playingBoard[endX+1][endY-1].black == true && parentNode.entry.playingBoard[endX+1][endY-1].king == true && parentNode.entry.playingBoard[endX-1][endY+1].empty == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX+1;
            tempBoard.beginningY = endY-1;
            tempBoard = tempBoard.singleMove(endX+1, endY-1, endX-1, endY+1);
            tempBoard.attackBlackKing(endX-1, endY+1, parentNode);
        }
        if (parentNode.entry.boundary(endX-1, endY-1, endX+1, endY+1) && parentNode.entry.playingBoard[endX-1][endY-1].black == true && parentNode.entry.playingBoard[endX-1][endY-1].king == true && parentNode.entry.playingBoard[endX+1][endY+1].empty == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX-1;
            tempBoard.beginningY = endY-1;
            tempBoard = tempBoard.singleMove(endX-1, endY-1, endX+1, endY+1);
            tempBoard.attackBlackKing(endX+1, endY+1, parentNode);
        }
        if (parentNode.entry.boundary(startX+2, startY-2, startX, startY) && parentNode.entry.playingBoard[startX+2][startY-2].black == true && parentNode.entry.playingBoard[startX+2][startY-2].king == true && parentNode.entry.playingBoard[startX+1][startY-1].red == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = endX+2;
            tempBoard.beginningY = endY-2;
            tempBoard = board.singleMove(startX+2, startY-2, startX, startY);
            tempBoard.attackBlackKing(startX, startY, parentNode);
        }
        if (parentNode.entry.boundary(startX-2, startY-2, startX, startY) && parentNode.entry.playingBoard[startX-2][startY-2].black == true && parentNode.entry.playingBoard[startX-2][startY-2].king == true && parentNode.entry.playingBoard[startX-1][startY-1].red == true)
        {
            //CheckerBoard tempBoard = board;
            CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
            tempBoard.beginningX = startX-2;
            tempBoard.beginningY = startY-2;
            tempBoard = board.singleMove(startX-2, startY-2, startX, startY);
            tempBoard.attackBlackKing(startX, startY, parentNode);
        }
        //End 3-7-04 1:30PM addition, although this is mirrored in the BlackInitialAttack method
    }
    
    public void minMax (CheckerBoard happyBoard, int start, int end)
    {
        if (decisionTree.rootNode.links[0] != null)
        {
            for (int i = 0; i < 24; i++)
            {
                if(decisionTree.rootNode.links[i] == null)
                {
                  System.out.println("ILLEGAL MOVE BUB");
                  break;
                  
                }
                  else
                  {
                    if (decisionTree.rootNode.links[i].entry.equivalent(happyBoard))
                    {
                          decisionTree.rootNode = decisionTree.rootNode.links[i];
                          break;
                     }
                  }
            }
        }
        
        //decisionTree.rootNode.plink = null;
        
        endTime = System.currentTimeMillis();
        String userInput = JOptionPane.showInputDialog(null, "Continue?");
        //while ((endTime - startTime) < 60000)
        while (userInput.equals("y"))
        //for (int i = 0; i < 2; i++)
        {
            traverse(decisionTree.rootNode);
            treeLevel++;
            userInput = JOptionPane.showInputDialog(null, "Continue?");
            endTime = System.currentTimeMillis();
        }
        // Find highest MMValue of decisionTree.rootNode.links[] and return all moves
        // TEMPORARY FIX:  find highest MMValue and print out ending state
        int i = 1;
        int tempMM = decisionTree.rootNode.links[0].MMValue;
        TreeNode printNode = decisionTree.rootNode.links[0];
        while (decisionTree.rootNode.links[i] != null)
        {
            if (tempMM < decisionTree.rootNode.links[i].MMValue)
            {
                tempMM = decisionTree.rootNode.links[i].MMValue;
                printNode = decisionTree.rootNode.links[i];
            }
            i++;
        }
        
        System.out.println("*********  Okama Gamesphere's Move  *********");
        printNode.entry.printState(first);
        printNode.entry.printMoves(first);
        numberOfMoves++;
        System.out.println("Number of moves:  " + numberOfMoves);
        // Set the root node equal to the current move to save some of our tree
        undoNode = decisionTree.rootNode.plink;
        decisionTree.rootNode = printNode;
        treeLevel-=2;
       
    }
    
    public void traverse(TreeNode pablo)
    {
        for (int i = 0; pablo.links[i] != null; i++)
        {
            if (i == 0)
            {
                pablo.MMValue = pablo.links[i].MMValue;
            }
            else if (decisionTree.findLevel(pablo) % 2 == 0)
            {
                if (pablo.links[i].MMValue < pablo.links[i - 1].MMValue)
                {
                    pablo.MMValue = pablo.links[i].MMValue;
                }
            }
            else
            {
                if (pablo.links[i].MMValue < pablo.links[i - 1].MMValue)
                {
                    pablo.MMValue = pablo.links[i].MMValue;
                }
            }
            traverse(pablo.links[i]);
        }
        //decisionTree.rootNode != pablo && (was inside of the if-clause below)
        if (pablo.links[0] == null)
        {
            parentNode = pablo; 
            successor(pablo.entry.conversion(pablo.entry.beginningX, pablo.entry.beginningY), pablo.entry.conversion(pablo.entry.endingX, pablo.entry.endingY));
            /*int i = 0;
            while (pablo.links[i] != null)
            {
                pablo.links[i].entry.printState();
                System.out.println("");
                i++;
            }
            System.out.println("-------------END LEVEL--------------------");*/
            //System.out.println();
        }
        // Save old root node for "do overs" and set root equal to the new node, printNode
    }
    
    public void driverFirst()
    {
        //decisionTree.rootNode.entry = decisionTree.rootNode.entry.singleMove(10, 15);
        /*board.playingBoard = board.copy(decisionTree.rootNode.entry.playingBoard);
        board.beginningX = 3;
        board.beginningY = 2;
        board.endingX = 4;
        board.endingY = 3;
        board.singleMove(3, 2, 4, 3);*/
        minMax(board, 10, 15);
        
        while (true)
        {
            driver();
        }
    }
    
    public void driver()
    {
        //CheckerBoard tempBoard = new CheckerBoard(board.copy(decisionTree.rootNode.entry.playingBoard));
        board.playingBoard = board.copy(decisionTree.rootNode.entry.playingBoard);
        String userInput = JOptionPane.showInputDialog(null, "Please enter the squares visited:");
        if (userInput.equals("undo"))
        {
            undo();
            driver();
        }
        else {
        startTime = System.currentTimeMillis();
        String[] input = userInput.split(",");
        int[] intInput = new int[input.length];
        for (int i = 0; i < input.length; i++)
        {
            intInput[i] = Integer.parseInt(input[i]);
        }
        
        if (!first)
        {
            for (int i = 0; i < intInput.length; i++)
            {
                intInput[i] = 33 - intInput[i];
            }
        }
        
        int start = intInput[0];
        int stop = intInput[intInput.length - 1];
        
        int[] current = new int[2];
        int[] next = new int[2];
        
        for (int i = 0; i < intInput.length - 1; i++)
        {
            current = board.conversion(intInput[i]);
            next = board.conversion(intInput[i + 1]);
            board = board.singleMove(current[0], current[1], next[0], next[1]);
            //System.out.println("Move:   "+ '('+current[0]+','+current[1]+") ->  (" + next[0] + ',' + next[1] + ')');
        }
        
                System.out.println();
                System.out.println("*********  Opponents's Move  *********");
                board.printState(first);
                numberOfMoves++;
                System.out.println();
        
        //TreeNode parent = new TreeNode(board);
        minMax(board, start, stop);
    }
    }
    
    public void successor(int start, int stop)
    {
        int[] begin = board.conversion(start);
        int[] end = board.conversion(stop);
    
        if (treeLevel % 2 == 0)
        {
            initialAttacks(begin[0], begin[1], end[0], end[1]);
            if (parentNode.links[0] == null)
            {
                for(int i =0; i < 8; i++){
                    
                    for(int j = 0; j < 8; j++){
                      if(parentNode.entry.playingBoard[j][i].red)
                      {
                        if(board.boundary(j, i, j-1, i+1) && parentNode.entry.playingBoard[j-1][i+1].empty){
                              //CheckerBoard tempBoard = new CheckerBoard(board.copy(board.playingBoard));
                              CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
                              tempBoard = tempBoard.singleMove(j, i, j-1, i+1);
                              tempBoard.beginningX = j;
                              tempBoard.beginningY = i;
                              tempBoard.endingX = j - 1;
                              tempBoard.endingY = i + 1;
                              TreeNode newNode = new TreeNode(tempBoard);
                              parentNode.addChild(newNode);
                         }
                         
                           if(board.boundary(j, i, j+1, i+1) && parentNode.entry.playingBoard[j+1][i+1].empty){
                              //CheckerBoard tempBoard = new CheckerBoard(board.copy(board.playingBoard));
                              CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
                              tempBoard = tempBoard.singleMove(j, i, j+1, i+1);
                              tempBoard.beginningX = j;
                              tempBoard.beginningY = i;
                              tempBoard.endingX = j + 1;
                              tempBoard.endingY = i + 1;
                              TreeNode newNode = new TreeNode(tempBoard);
                              parentNode.addChild(newNode);
                         }
                          
                      
                      
                         if(parentNode.entry.playingBoard[j][i].king)
                         {
                             
                          if(board.boundary(j, i, j-1, i-1) && parentNode.entry.playingBoard[j-1][i-1].empty){
                              //CheckerBoard tempBoard = new CheckerBoard(board.copy(board.playingBoard));
                              CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
                              tempBoard = tempBoard.singleMove(j, i, j-1, i-1);
                              tempBoard.beginningX = j;
                              tempBoard.beginningY = i;
                              tempBoard.endingX = j - 1;
                              tempBoard.endingY = i - 1;
                              TreeNode newNode = new TreeNode(tempBoard);
                              parentNode.addChild(newNode);
                         }
                              
                            if(board.boundary(j, i, j+1, i-1) && parentNode.entry.playingBoard[j+1][i-1].empty){
                              //CheckerBoard tempBoard = new CheckerBoard(board.copy(board.playingBoard));
                              CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
                              tempBoard = tempBoard.singleMove(j, i, j+1, i-1);
                              tempBoard.beginningX = j;
                              tempBoard.beginningY = i;
                              tempBoard.endingX = j + 1;
                              tempBoard.endingY = i - 1;
                              TreeNode newNode = new TreeNode(tempBoard);
                              parentNode.addChild(newNode);
                         }    
                              
                              
                              
                      }
                        
                        
                      }
                }
                 
             }
         }
                    
        }
        
        else
        {
                  
                BlackInitialAttacks(begin[0], begin[1], end[0], end[1]);
                if (parentNode.links[0] == null)
               {
                    for(int i =0; i < 8; i++){
                    
                    for(int j = 0; j < 8; j++){ 
                      
                      
                         if(parentNode.entry.playingBoard[j][i].black)
                         {
                             
                          if(board.boundary(j, i, j-1, i-1) && parentNode.entry.playingBoard[j-1][i-1].empty){
                              //CheckerBoard tempBoard = new CheckerBoard(board.copy(board.playingBoard));
                              CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
                              tempBoard = tempBoard.singleMove(j, i, j-1, i-1);
                              tempBoard.beginningX = j;
                              tempBoard.beginningY = i;
                              tempBoard.endingX = j - 1;
                              tempBoard.endingY = i - 1;
                              TreeNode newNode = new TreeNode(tempBoard);
                              parentNode.addChild(newNode);
                         }
                              
                            if(board.boundary(j, i, j+1, i-1) && parentNode.entry.playingBoard[j+1][i-1].empty){
                              //CheckerBoard tempBoard = new CheckerBoard(board.copy(board.playingBoard));
                              CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
                              tempBoard = tempBoard.singleMove(j, i, j+1, i-1);
                              tempBoard.beginningX = j;
                              tempBoard.beginningY = i;
                              tempBoard.endingX = j + 1;
                              tempBoard.endingY = i - 1;
                              TreeNode newNode = new TreeNode(tempBoard);
                              parentNode.addChild(newNode);
                         }    
                              
                              
                        if(parentNode.entry.playingBoard[j][i].king)
                      {
                           if(board.boundary(j, i, j-1, i+1) && parentNode.entry.playingBoard[j-1][i+1].empty){
                              //CheckerBoard tempBoard = new CheckerBoard(board.copy(board.playingBoard));
                              CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
                              tempBoard = tempBoard.singleMove(j, i, j-1, i+1);
                              tempBoard.beginningX = j;
                              tempBoard.beginningY = i;
                              tempBoard.endingX = j - 1;
                              tempBoard.endingY = i + 1;
                              TreeNode newNode = new TreeNode(tempBoard);
                              parentNode.addChild(newNode);
                         }
                         
                           if(board.boundary(j, i, j+1, i+1) && parentNode.entry.playingBoard[j+1][i+1].empty){
                              //CheckerBoard tempBoard = new CheckerBoard(board.copy(board.playingBoard));
                              CheckerBoard tempBoard = new CheckerBoard(board.copy(parentNode.entry.playingBoard));
                              tempBoard = tempBoard.singleMove(j, i, j+1, i+1);
                              tempBoard.beginningX = j;
                              tempBoard.beginningY = i;
                              tempBoard.endingX = j + 1;
                              tempBoard.endingY = i + 1;
                              TreeNode newNode = new TreeNode(tempBoard);
                              parentNode.addChild(newNode);
                         }        
                     }
                      
                        
                        
                   }
            
          }
      }
      
  }
  
  
}
    //treeLevel++;
}

    public void undo()
    {
        decisionTree.rootNode = decisionTree.rootNode.plink.plink;
        //decisionTree.rootNode = undoNode.copy(undoNode);
        System.out.println("*************  Redo state  ***************");
        decisionTree.rootNode.entry.printState(first);
    }

}
