
/**
 * This is a typical LinkedList class.  Most methods have descriptions preceding them.
 * 
 * @author Mark Brown
 * @course AI
 * @version January 27, 2004 - Project 1
 */
public class LinkedList
{
    /*** Instance Variables ***/
    private int length;
    private ListNode firstNode;
    
    /*** Constructor ***/
    public LinkedList()
    {
        length = 0;
        firstNode = null;
    }
    
    /*** Instance Methods ***/
    public int returnSize()
    {
        return length;
    }
    
    public boolean emptyList()
    {
        if (firstNode == null)
            return true;
        else
            return false;
    }
    
    public void addAtTail(ListNode newNode)
    {
        ListNode runner;
        runner = firstNode;
        if (firstNode == null)
        {
            firstNode = newNode;
        }
        else
        {
            while (runner.link != null)
            {
                runner = runner.link;
            }
            runner.link = newNode;
        }
        length++;
    }
    
    public ListNode removeFromHead()
    {
        if (this.emptyList())
            return null;
        else
        {
            ListNode tempNode;
            tempNode = firstNode;
            firstNode = firstNode.link;
            length--;
            return tempNode;
        }
    }
    
    // Get the node prior to nextNode
    private ListNode getPreviousNode(ListNode nextNode)
    {
        ListNode runner;
        runner = firstNode;
        if (nextNode == firstNode)
            return null;
        else
        {
            while (runner.link != nextNode)
            {
                runner = runner.link;
            }
            return runner;
        }
    }// end of getPreviousNode
    
    // Returns and removes the last node of the list
    public ListNode returnAndRemove()
    {
        if (this.emptyList())
        {
            return null;
        }
        else
        {
            ListNode runner;
            runner = firstNode;
            while (runner.link != null)
            {
                runner = runner.link;
            }
            ListNode temp;
            temp = runner;
            if (runner == firstNode)
            {
                firstNode = null;
            }
            else
            {
                ListNode prevNode;
                prevNode = this.getPreviousNode(runner);
                prevNode.link = null;
            }
            length--;
            return temp;
        }
    }
    
    // Only returns the last node of the list
    public ListNode returnTop()
    {
        if (this.emptyList())
        {
            return null;
        }
        else
        {
            ListNode runner;
            runner = firstNode;
            while (runner.link != null)
            {
                runner = runner.link;
            }
            return runner;
        }
    }
}
