import java.awt.*;
import java.util.*;

// class checkers
// this class controls the checkers engine and the agent's move
public class Checkers {

    // the board, and some constants
    static int[][] board = new int[8][4];
    static final int EMPTY = 0;
    static final int WHITE = 1;
    static final int RED = 2;
    static final int WHITEKING = 3;
    static final int REDKING = 4;
    static int numRed = 12;
    static int numWhite = 12;
    int turn = RED;
    
    // reset the board to its initial state
    public void Reset ()
    {
	for (int row=0; row<8; row++)
	    {
		for (int col=0; col<4; col++)
		    {
			if (row<3) board[row][col] = RED;
			else if (row<5) board[row][col] = EMPTY;
			else board[row][col] = WHITE;
		    }
	    }

// 	board[3][1] = WHITE;
// 	board[3][2] = WHITE;
// 	board[5][3] = WHITE;
// 	board[6][3] = EMPTY;
// 	board[6][1] = EMPTY;
// 	board[2][1] = REDKING;

// 	board[1][2] = EMPTY;
// 	board[2][2] = EMPTY;
// 	board[2][3] = WHITE;
// 	board[3][2] = REDKING;
// 	board[3][3] = RED;
// 	board[4][2] = WHITE;
// 	board[5][2] = EMPTY;
// 	board[5][3] = EMPTY;
// 	board[6][2] = WHITE;
// 	board[6][3] = EMPTY;
// 	board[7][1] = EMPTY;
// 	board[7][3] = EMPTY;

/*
	board = new int[][] { {   0, 0, 0, 0, },
			      { 2, 0, 0, 0, },
			      {	  0, 2, 2, 2, },
			      { 0, 0, 4, 0, },
			      {   0, 0, 0, 0, },
			      { 1, 0, 0, 1, },
			      {   0, 0, 0, 0, },
			      { 0, 0, 0, 0 } };
*/
    }

    // print out a board all nice and pretty like
    public static void Print (int[][] b)
    {
	for (int row = 0; row < 8; row += 2)
	    {
		System.out.print (" ");
		for (int col=0; col<4; col++)
		    {
			if (b[row][col] == EMPTY) System.out.print ("E");
			else if (b[row][col] == WHITE) System.out.print ("w");
			else if (b[row][col] == RED) System.out.print ("r");
			else if (b[row][col] == WHITEKING) System.out.print ("W");
			else if (b[row][col] == REDKING) System.out.print ("R");
			if (col != 3) System.out.print (" ");
		    }
		System.out.println ();
		for (int col=0; col<4; col++)
		    {
			if (b[row+1][col] == EMPTY) System.out.print ("E");
			else if (b[row+1][col] == WHITE) System.out.print ("w");
			else if (b[row+1][col] == RED) System.out.print ("r");
			else if (b[row+1][col] == WHITEKING) System.out.print ("W");
			else if (b[row+1][col] == REDKING) System.out.print ("R");
			System.out.print (" ");
		    }
		System.out.println();
	    }
	System.out.println();
    }

    // given a board, position and turn, returns a vector containing integer arrays that
    // represent all moves that can be made from that position
    public static Vector GetPositionMoves (int[][] b, int r, int c, int turn)
    {
	Vector moves = new Vector();
	int[] move;
	
	if (r != 7 && (turn == RED || b[r][c] == WHITEKING))
	    {
		if (b[r+1][c] == EMPTY)
		    {
			move = new int[] { r, c, r+1, c };
			moves.add (move);
		    }
		
		// in an odd row, can move down one row and
		// same column or one column left, unless all the way left already
		if (r % 2 == 1)
		    {
			if (c != 0 && b[r+1][c-1] == EMPTY)
			    {
				move = new int[] { r, c, r+1, c-1 };
				moves.add (move);
			    }
		    }
			
		// in an even row, can move down one row and same column
		// or one column right, unless all the way right already
		else if (c != 3 && b[r+1][c+1] == EMPTY) 
		    {
			move = new int[] { r, c, r+1, c+1 };
			moves.add (move);
		    }	
	    }
	if (r != 0 && (turn == WHITE || b[r][c] == REDKING))
	    {
		// can alway move one row up and keep same column
		// (if it's empty that is)
		if (b[r-1][c] == EMPTY)
		    {
			move = new int[] { r, c, r-1, c };
			moves.add (move);
		    }

		// in odd row, can move up one row and same column or
		// one column left, unless all the way left already
		if (r % 2 == 1)
		    {
			if (c != 0 && b[r-1][c-1] == EMPTY)
			    {
				move = new int[] { r, c, r-1, c-1 };
				moves.add (move);
			    }
		    }
		// in an even row, can move up one row and same column or
		// one column right, unless all the way right already (c=3)
		else if (c != 3 && b[r-1][c+1] == EMPTY)
		    {
			move = new int[] { r, c, r-1, c+1 };
			moves.add (move);
		    }
		   
	    }
	return moves;			
    }

    // get the opponent color of a piece
    public static int GetOpponent (int piece)
    {
	if (piece == RED || piece == REDKING) return WHITE;
	else if (piece == WHITE || piece == WHITEKING) return RED;
	else System.out.println ("Something is wrong with GetOpponent...");
	return 0;
    }

    // get the turn of a piece
    public static int GetTurn (int piece)
    {
	if (piece == RED || piece == REDKING) return RED;
	else if (piece == WHITE || piece == WHITEKING) return WHITE;
	//else System.out.println ("Something is wrong with GetTurn...");
	else return EMPTY;
    }

    // given a board, a position on it, and a turn, tells if the piece
    // at that position has any jumps
    public static boolean Jump (int[][] b, int r, int c, int turn)
    {
	// get the color of the guy being jumped
	int jumpee = GetOpponent (b[r][c]);

	if (r != 7 && (turn == RED || b[r][c] == WHITEKING))
	    {		
		// on an even row
		if (r % 2 == 0)
		    {
			// jump down left
			if (r + 2 < 8 && c - 1 >= 0 &&
			    GetTurn(b[r+1][c]) == jumpee &&
			    b[r+2][c-1] == EMPTY) return true;
			
			// jump down right
			if (r + 2 < 8 && c + 1 < 4 &&
			    GetTurn(b[r+1][c+1]) == jumpee &&
			    b[r+2][c+1] == EMPTY) return true;
		    }
		else // on an odd row
		    {
			// jump down left
			if (r + 2 < 8 && c - 1 >= 0 &&
			    GetTurn(b[r+1][c-1]) == jumpee &&
			    b[r+2][c-1] == EMPTY) return true;
			
			// jump down right
			if (r + 2 < 8 && c + 1 < 4 &&
			    GetTurn(b[r+1][c]) == jumpee &&
			    b[r+2][c+1] == EMPTY) return true;
		    }
	    }
	if (r != 0 && (turn == WHITE || b[r][c] == REDKING))
	    {
		// on an even row
		if (r % 2 == 0)
		    {
			// jump up left
			if (r - 2 >= 0 && c - 1 >= 0 && 
			    GetTurn(b[r-1][c]) == jumpee &&
			    b[r-2][c-1] == EMPTY) return true;

			// jump up right
			if (r - 2 >= 0 && c + 1 < 4 &&
			    GetTurn(b[r-1][c+1]) == jumpee &&
			    b[r-2][c+1] == EMPTY) return true;
		    }
		else // odd row
		    {
			// jump up left
			if (r - 2 >= 0 && c - 1 >= 0 &&
			    GetTurn(b[r-1][c-1]) == jumpee &&
			    b[r-2][c-1] == EMPTY) return true;

			// jump up right
			if (r - 2 >= 0 && c + 1 < 4 &&
			    GetTurn(b[r-1][c]) == jumpee &&
			    b[r-2][c+1] == EMPTY) return true;
		    }
	    }
		
	return false;
    }

    // given a board, a position, a turn and the color of the guy being jumped, returns a vector containing
    // integer arrays that represent all jumps that can be made from the given position
    // recursively calls itself after each jump to check for multiple jumps
    public static Vector GetPositionJumps (int[][] b, int r, int c, int turn, int jumpee, int[] callingMove)
    {
	Vector jumps = new Vector();
	int move[] = new int[4];
	int[][] tempBoard = new int[8][4];
	Vector otherJumps = new Vector();

	// if a jump results in a king, the jump chain should stop
	// that's what this flag is for
	boolean king = false;
	
	if (r != 7 && ((turn == RED && GetTurn(b[r][c]) == RED) || (b[r][c] == WHITEKING && turn == WHITE)))
	    {
		// on an even row
		if (r % 2 == 0)
		    {
			// jump down left
			if (r + 2 < 8 && c - 1 >= 0 &&
			    GetTurn(b[r+1][c]) == jumpee &&
			    b[r+2][c-1] == EMPTY) {
			    move = new int[] { r, c, r+2, c-1 };
			    jumps.add (move);
			    tempBoard = GetBoardCopy(b);
			    king = UpdateBoard (tempBoard, move, turn);
			    if (!king && Jump(tempBoard, r+2, c-1, turn))
				{
				    //otherJumps = GetPositionJumps (tempBoard, r+2, c-1, turn, jumpee, move);
				    //if (callingMove[0] != -1000) jumps.add (callingMove);
				    //jumps.addAll (otherJumps);
				    jumps.addAll (GetPositionJumps (tempBoard, r+2, c-1, turn, jumpee, move));
				}
			    /*
			    else
				{
				    if (callingMove[0] != -1000) jumps.add (callingMove);
				    jumps.add (move);
				}
			    */
			}
					    					
			// jump down right
			if (r + 2 < 8 && c + 1 < 4 &&
			    GetTurn(b[r+1][c+1]) == jumpee &&
			    b[r+2][c+1] == EMPTY) {
			    move = new int[] { r, c, r+2, c+1 };
			    jumps.add (move);
			    tempBoard = GetBoardCopy(b);
			    king = UpdateBoard (tempBoard, move, turn);
			    if (!king && Jump(tempBoard, r+2, c+1, turn))
				{
				    //otherJumps = GetPositionJumps (tempBoard, r+2, c+1, turn, jumpee, move);
				    //if (callingMove[0] != -1000) jumps.add (callingMove);
				    //jumps.addAll (otherJumps);
				    jumps.addAll (GetPositionJumps (tempBoard, r+2, c+1, turn, jumpee, move));
				}
			    /*
			    else 
				{
				    if (callingMove[0] != -1000) jumps.add (callingMove);
				    jumps.add (move);
				}
			    */
			}
		    }
		else // on an odd row
		    {
			// jump down left
			if (r + 2 < 8 && c - 1 >= 0 &&
			    GetTurn(b[r+1][c-1]) == jumpee &&
			    b[r+2][c-1] == EMPTY) {
			    move = new int[] { r, c, r+2, c-1 };
			    jumps.add (move);
			    tempBoard = GetBoardCopy(b);
			    king = UpdateBoard (tempBoard, move, turn);
			    if (!king && Jump(tempBoard, r+2, c-1, turn))
				{
				    //otherJumps = GetPositionJumps (tempBoard, r+2, c-1, turn, jumpee, move);
				    //if (callingMove[0] != -1000) jumps.add (callingMove);
				    //jumps.addAll (otherJumps);
				    jumps.addAll (GetPositionJumps (tempBoard, r+2, c-1, turn, jumpee, move));
				}
			    /*
			    else 
				{
				    if (callingMove[0] != -1000) jumps.add (callingMove);
				    jumps.add (move);
			    }
			    */
			}
					
			// jump down right
			if (r + 2 < 8 && c + 1 < 4 &&
			    GetTurn(b[r+1][c]) == jumpee &&
			    b[r+2][c+1] == EMPTY) {
			    move = new int[] { r, c, r+2, c+1 };
			    jumps.add (move);
			    tempBoard = GetBoardCopy(b);
			    king = UpdateBoard (tempBoard, move, turn);
			    if (!king && Jump(tempBoard, r+2, c+1, turn))
				{
				    //otherJumps = GetPositionJumps (tempBoard, r+2, c+1, turn, jumpee, move);
				    //if (callingMove[0] != -1000) { jumps.add (callingMove); System.out.println ("arr"); }
				    //jumps.addAll (otherJumps);
				    jumps.addAll (GetPositionJumps (tempBoard, r+2, c+1, turn, jumpee, move));
				}
			    /*
			    else 
				{
				    if (callingMove[0] != -1000) jumps.add (callingMove);
				    jumps.add (move);
				}
			    */
			}
		    }
	    }
	if (r != 0 && ((turn == WHITE && GetTurn (b[r][c]) == WHITE) || (b[r][c] == REDKING && turn == RED)))
	    {
		// on an even row
		if (r % 2 == 0)
		    {
			// jump up left
			if (r - 2 >= 0 && c - 1 >= 0 && 
			    GetTurn(b[r-1][c]) == jumpee &&
			    b[r-2][c-1] == EMPTY) {
			    move = new int[] { r, c, r-2, c-1 };
			    jumps.add (move);
			    tempBoard = GetBoardCopy(b);
			    king = UpdateBoard (tempBoard, move, turn);
			    if (!king && Jump(tempBoard, r-2, c-1, turn))
				{
				    //otherJumps = GetPositionJumps (tempBoard, r-2, c-1, turn, jumpee, move);
				    //if (callingMove[0] != -1000) { jumps.add (callingMove); }
				    //jumps.addAll (otherJumps);
				    jumps.addAll (GetPositionJumps (tempBoard, r-2, c-1, turn, jumpee, move));
				}
			    /*
			    else
				{
				    if (callingMove[0] != -1000) jumps.add (callingMove);
				    jumps.add (move);
				}
			    */
			}
					
			// jump up right
			if (r - 2 >= 0 && c + 1 < 4 &&
			    GetTurn( b[r-1][c+1]) == jumpee &&
			    b[r-2][c+1] == EMPTY) {
			    move = new int[] { r, c, r-2, c+1 };
			    jumps.add (move);
			    tempBoard = GetBoardCopy(b);
			    king = UpdateBoard (tempBoard, move, turn);
			    if (!king && Jump(tempBoard, r-2, c+1, turn))
				{
				    //otherJumps = GetPositionJumps (tempBoard, r-2, c+1, turn, jumpee, move);
				    //if (callingMove[0] != -1000) { jumps.add (callingMove); }
				    //jumps.addAll (otherJumps);
				    jumps.addAll (GetPositionJumps (tempBoard, r-2, c+1, turn, jumpee, move));
				}
			    /*
			    else
				{
				    if (callingMove[0] != -1000) jumps.add (callingMove);
				    jumps.add (move);
				}
			    */
			}
		    }
		else // odd row
		    {
			// jump up left
			if (r - 2 >= 0 && c - 1 >= 0 &&
			    GetTurn(b[r-1][c-1]) == jumpee &&
			    b[r-2][c-1] == EMPTY) {
			    move = new int[] { r, c, r-2, c-1 };
			    jumps.add (move);
			    tempBoard = GetBoardCopy(b);
			    king = UpdateBoard (tempBoard, move, turn);
			    if (!king && Jump(tempBoard, r-2, c-1, turn))
				{
				    //otherJumps = GetPositionJumps (tempBoard, r-2, c-1, turn, jumpee, move);
				    //if (callingMove[0] != -1000) { jumps.add (callingMove); }
				    //jumps.addAll (otherJumps);
				    jumps.addAll (GetPositionJumps (tempBoard, r-2, c-1, turn, jumpee, move));
				}
			    /*
			    else
				{
				    if (callingMove[0] != -1000) jumps.add (callingMove);
				    jumps.add (move);
				}
			    */
			}
					
			// jump up right
			if (r - 2 >= 0 && c + 1 < 4 &&
			    GetTurn(b[r-1][c]) == jumpee &&
			    b[r-2][c+1] == EMPTY) {
			    move = new int[] { r, c, r-2, c+1 };
			    jumps.add (move);
			    tempBoard = GetBoardCopy(b);
			    king = UpdateBoard (tempBoard, move, turn);
			    if (!king && Jump(tempBoard, r-2, c+1, turn))
				{
				    //otherJumps = GetPositionJumps (tempBoard, r-2, c+1, turn, jumpee, move);
				    //if (callingMove[0] != -1000) { jumps.add (callingMove); }
				    //jumps.addAll (otherJumps);
				    jumps.addAll (GetPositionJumps (tempBoard, r-2, c+1, turn, jumpee, move));
				}
			    /*
			    else
				{
				    if (callingMove[0] != -1000) jumps.add (callingMove);
				    jumps.add (move);
				}
			    */
			}
		    }
	    }
	return jumps;
    }

    // given a board and a turn, return a vector of integer arrays representing all jumps that can be made
    // from this board.  basically calls GetPositionJumps on each piece on the board of the correct color
    public static Vector GetJumps (int[][] b, int turn)
    {
	Vector jumps = new Vector();
	int move[] = new int[4];

	// get the color of the guy being jumped
	int jumpee = GetOpponent (turn);
	
	for (int r=0; r<8; r++)
	    {
		for (int c=0; c<4; c++)
		    {
			if (b[r][c] == EMPTY) continue;
			else if (GetTurn (b[r][c]) == turn)
			{
			    jumps.addAll (GetPositionJumps (b, r, c, turn, jumpee, new int[] { -1000,0,0,0 }));
			}
		    }
				 
	    }    
	// the vector returned by GetPositionJumps isn't correct for multiple jumps, so FixMoveList takes in the
	// vector of moves and fixes it up so all the multiple jumps are correct
	return FixMoveList (jumps, b);
    }

    // takes a move and returns true if it is a jump
    public static boolean IsJump (int[] move)
    {
	return (Math.abs (move[0] - move[2]) == 2);
    }

    // checks if the game is over...returns 0 if not done, otherwise
    // returns the loser (RED or WHITE), which is the winner in this case
    public int IsGameOver (int moves, int turn)
    {
	// no legal moves
	if (moves == 0) return turn;

	return 0;
    }
    
    // return a vector containing all possible moves given turn=RED or WHITE
    // the vector contains int arrays which contain the coordinates of the piece
    // moving and its ending position
    public static Vector GetMoves (int[][] b, int turn)
    {
	// vector to hold all the possible moves
	Vector moves = new Vector(); 

	for (int r=0; r<8; r++)
	    {
		for (int c=0; c<4; c++)
		    {
			// check if the current square contains a checker of
			// whoever's turn it is
			if (GetTurn(b[r][c]) == turn)
			    {
				// if there's a jump at this spot, then it has to be done
				// unless there are others, so find all possible jumps for
				// this configuration and return them as the move list
				if (Jump (b, r, c, turn))
				    {
					return GetJumps (b, turn);
				    }
				
				// no jumps so far, so add all possible moves from the current
				// square to the move list
				moves.addAll (GetPositionMoves (b, r, c, turn));
				
			    }
		    }
	    }
	return moves;
    }

    // check if a particular move has already been put into the move list,
    // so the same move isn't generated multiple times
    public static boolean AlreadyGenerated (Vector moves, int[] move)
    {
	for (int i=0; i < moves.size()-1; i++)
	    {
		if (Arrays.equals (move, (int[])moves.get(i))) return true;
	    }
	return false;
    }

    // take a vector of int arrays that represent moves, and make it into a new vector that contains
    // arrays of various sizes representing all moves.  For instance, calling GetMoves will return
    // a vector holding the moves, but they will all be arrays of size 4 so multiple jumps won't all
    // be together.  This function makes a multiple jump move that would have been made of a few arrays
    // of 4 ints into one larger array.  It leaves non-multiple jumps alone.
    // This function only needs to be used when there are jumps, since regular moves are always in the 
    // same form.
    // the input move vector is called moves, and the new move vector is put into the vector tempMoves
    // don't even try to understand this function, i hardly do and i wrote it
    public static Vector FixMoveList (Vector moves, int[][] b)
    {
	int[] move = new int[4];
	int[] temp1, temp2;
	int moveLength;
	Vector tempMoves = new Vector();
	int numTempMoves = 0;
	int moveSize = moves.size();
	int j;

	// used as a flag to make sure a vector element isn't accessed before it is added
	boolean multiple = false;

	// if a move is used as the start of a multiple jump, there is no way it could be
	// added as a jump by itself.  this flag makes sure of this, and also that a non-multiple
	// jump will just be added to the list on its own.
	boolean usedAsStart = false;

	// flag to tell if it is the first time through the j loop for a particular i
	boolean firstJ = true;

	// loop through all the moves in the list
	for (int i=0; i < moveSize; i++)
	    {
		usedAsStart = false;
		j = i + 1;
		firstJ = true;

		// loop through all the remaining elements
		while (j < moveSize)
		    {			
			multiple = false;
			int firstMove = i, secondMove = j;

			// put the first move in an array
		        temp1 = (int[])moves.get(firstMove);

			// just an in-between move, shouldnt be used as a starting
			// point, so skip it
			if (b[temp1[0]][temp1[1]] == EMPTY) 
			    {
				usedAsStart = true;
				//j++;
				j = moveSize;
				continue;
			    }

			// put the next move in an array
			temp2 = (int[])moves.get(secondMove);
			moveLength = temp1.length;

			// two moves match, they are a multiple jump
			// ie, the last two elements of the first move, and the first two elements
			// of the next move
			// so, while that's true, put them together
			while (temp1[moveLength-2] == temp2[0] && temp1[moveLength-1] == temp2[1] &&
			       (temp1[moveLength-4] != temp2[2] || temp1[moveLength-3] != temp2[3]))
			    {
				// stick the two moves together
				move = new int[moveLength + 2];
				System.arraycopy (temp1, 0, move, 0, moveLength);
				System.arraycopy (temp2, 2, move, moveLength, 2);

				// so we can check the next move
				secondMove++;

				if (!multiple) tempMoves.add (move);
				else tempMoves.set (numTempMoves, move);
			
				temp1 = (int[])tempMoves.get(numTempMoves);
				
				moveLength = temp1.length;
				multiple = true;
			
				usedAsStart = true;
				if (secondMove >= moves.size()) break;
				temp2 = (int[])moves.get(secondMove);
			    }
			// after all is said and done, if the last move put in was actually already in there, take it out
			// can't be done in the while loop because i said so
			if (multiple && AlreadyGenerated (tempMoves, move))
			    {
				moves.removeElementAt (secondMove - 1);
				tempMoves.removeElementAt (numTempMoves-1);
				numTempMoves--;
				if (secondMove-1 >= moves.size() || secondMove-2 < 0) j++;
				else
				    {
					temp1 = (int[])moves.get(secondMove-2);
					temp2 = (int[])moves.get(secondMove-1);
					
					if (temp1[2] != temp2[0] || temp1[3] != temp2[1]) { j++; }
				    }
			    }
			else if (!firstJ) { j++; }
			firstJ = false;
			numTempMoves = tempMoves.size();
			moveSize = moves.size();
			
		    } // end j loop
		// wasn't a multiple jump, so just add it to the list as is
		if (!usedAsStart)
		    {
			int m[] = (int[])moves.get(i);

			if (b[m[0]][m[1]] != EMPTY)
			    {
				tempMoves.add (m);
				numTempMoves++;
			    }
		    }
	    } // end i loop

	return tempMoves;
    }
	

    // set a given board equal to the member var board of class Checkers
    public static void CopyBoard (int[][] b)
    {
	for (int r=0; r<8; r++)
	    for (int c=0; c<4; c++)
		b[r][c] = board[r][c];
    }

    // return a copy of an input board
    public static int[][] GetBoardCopy(int[][] b){
	int[][] copy = new int[8][4];
	
	for (int i=0; i<8; i++)
	    System.arraycopy(b[i],0,copy[i],0,4);
	return copy;
    }

    // update a board with a given move
    // returns true if a king is made, false otherwise, since when making jumps
    // a king will end the chain, so the function GetPositionJumps needs to know
    // if a king was made on a given move
    public static boolean UpdateBoard (int[][] b, int[] move, int turn)
    {
	boolean king = false;

	int a = 0;
	int r1 = move[0];
	int c1 = move[1];
	int r2 = move[2];
	int c2 = move[3];

	b[r2][c2] = b[r1][c1];
	b[r1][c1] = EMPTY;

	// promote kings if needed
	if (r2 == 7 && turn == RED) { b[r2][c2] = REDKING; king = true; }
	else if (r2 == 0 && turn == WHITE) { b[r2][c2] = WHITEKING; king = true; }

	// if the move is a jump, need to remove the checker being jumped
	if (IsJump (move))
	    {
		// coordinates of the piece being jumped
		int jr, jc = 0;
		// up jump
		if (r1 - r2 > 0) jr = r1 - 1;
		// down jump
		else jr = r1 + 1;

		if ((r1 % 2 == 0 && c1 - c2 > 0) ||
		    (r1 % 2 == 1 && c1 - c2 < 0)) jc = c1;
		
		else if (r1 % 2 == 0 && c1 - c2 < 0) jc = c1 + 1;
		else if (r1 % 2 == 1 && c1 - c2 > 0) jc = c1 - 1;
		else System.out.println ("JUMP TEST FAILED...");

		b[jr][jc] = EMPTY;

		// move to somewhere else...
		// ******************************
		if (turn == RED) numWhite--;
		else if (turn == WHITE) numRed--;
	    }
	// if the length of the move array is more than 4 it is a multiple jump,
	// so just make a recursive call with the rest of the move
	if (move.length > 4)
	    {
		int m[] = new int[move.length - 2];
		System.arraycopy (move, 2, m, 0, move.length - 2);
		UpdateBoard (b, m, turn);
	    }
	return king;
    }

    // print out a move
    public static void PrintMove (int[] move, int turn)
    {
	int a = 0;
	if (turn == RED) System.out.print ("Red's move: ");
	else System.out.print ("White's move: ");
	while (a + 2 <= move.length)
	    {
		int start = move[a] * 4 + move[a+1] + 1;
		//int end = move[a+2] * 4 + move[a+3] + 1;
		System.out.print (start + "-");
		a += 2;
	    }
	System.out.println();
    }

    // get all possible moves, search for best one and do it
    // uses the Search class which implements alpha-beta searching
    public boolean AIMove (int [][] b, int turn)
    {
	Print (b);

	int[] move = new int[4];

	// the index of the best move available
	// since minimax returns a score (and not a move), it also takes this array in and puts into
	// it the index of the best move.  So, after minimax simply generate the moves for depth=1 (which is
	// very fast) and use index[0] to know the index of the best move in that list
	int[] index = new int[1];

	int score;

	// get all possible moves and put them in a vector
	Vector moves = GetMoves (b, turn);

	if (moves.size() == 1) 
	    {
		index[0] = 0;
		System.out.println ("Force move");
	    }
	else
	    {

		// use the search function to find the best move
		// red calls maxvalue, white calls minvalue
		if (turn == RED) score = Search.MaxValue (b, 0, index, turn, -Integer.MAX_VALUE, Integer.MAX_VALUE);
		else score = Search.MinValue (b, 0, index, turn, -Integer.MAX_VALUE, Integer.MAX_VALUE);
		
		System.out.println ("Best score: " + score);
	    }

	// check for end game
        int gameStatus = IsGameOver (moves.size(), turn);

	// game is over
	if (gameStatus != 0)
	    {
		if (gameStatus == RED) System.out.println ("Red loses (and by that I mean wins)");
		else if (gameStatus == WHITE) System.out.println ("White loses (and by that I mean wins)");
		else System.out.println ("Someone lost, but it wasn't red or white...");
		return false;
	    }

	// using the index obtained from minimax, put the best move in an array called move
	move = (int[])moves.get(index[0]);

	// debugging
	if (IsJump (move)) System.out.println ("JUMP!");

	// print the move
	System.out.print ("--AI MOVE-->");
	PrintMove (move, turn);
	System.out.println ("Total moves: " + moves.size());

	// apply the move to the board
	UpdateBoard (b, move, turn);

	// print out what all the possible moves were
	for (int i=0; i<moves.size(); i++)
	    {
		move = (int[])moves.get(i);
		PrintMove (move, turn);
	    }

	Print (b);
	CopyBoard (b);
	return true;
    }
}








