public class JumpSuccessor implements Comparable {

    private Piece piece;
    private String jump;
    private int jumpValue;
    
    public JumpSuccessor (Piece p, String j, int jV) {
        piece = p;
        jump = j;
        jumpValue = jV;
    }
    
    public int getJumpValue() {
        return jumpValue;
    }

    public Piece getPiece()  {
        return piece;
    }
    
    public void addJump (String jumpStr) {
    	if (jump == "") {
    		jump = jumpStr;
    	} else {
    		String[] j = jumpStr.split ("-");
    		jump = jump + "-" + j[j.length-1];
    		jumpValue += 1;
    	}
    }
    
    public String getJump() {
        return jump;
    }
    
    public void setJumpValue (int m) {
        jumpValue = m;
    }

    public int compareTo (Object o) {
        Integer m = new Integer (jumpValue);
        JumpSuccessor mS = (JumpSuccessor) o;
        Integer n = new Integer (mS.getJumpValue());
        
        return m.compareTo (n);
    }   
    
    public String toString() {
    	return jump;
    }
}
