import java.util.*;
import java.io.*;
/**
 * Prompts the human player (the opponent agent) for its next (hopefully valid) move.
 * 
 * 1) Parses the input provided to sequences of numbers
 * 2) Checks the input to make sure it's a valid number sequence or the word UNDO
 * 
 * @author Umar Munroe
 * @author Cheryl Yager
 * @version 1.0
 */
public class Move
{
	/**
	 * Constructor for objects of class Move
	 */
		
	public static int[] getMove() throws IOException
	{
		int[] moves = null;
		InputStreamReader isr;
		//StreamTokenizer st;
		String input;
		BufferedReader in;
		int numTokens;
		boolean validInput = false;
		while (validInput == false)
		{
			System.out
					.println("Please input a VALID move (i.e. 11-15 or 23-14-5):");
			System.out.println("Enter UNDO to take back your last move.");
			in = new BufferedReader(new InputStreamReader(System.in));
			input = in.readLine();
			StringTokenizer st = new StringTokenizer(input, "-");
			numTokens = st.countTokens();
			if (numTokens >= 2)
			{
				moves = new int[numTokens];
				int i = 0;
				try
				{
					while (st.hasMoreElements())
					{
						moves[i] = Integer.parseInt(st.nextToken());
						i++;
					}
					validInput = true;
				}
				catch (NumberFormatException e)
				{
					validInput = false;
					System.out.println("ERROR: Input move not a number!");
				}
			}
			else
			{
				if ((numTokens == 1)
						&& (st.nextToken().trim().toLowerCase().compareTo(
								"undo") == 0))
				{
					validInput = true;
					moves = null;
				}
			}
		}
		return moves;
	}
	/**
	 * 
	 * @param y a sample parameter for a method
	 * @return the sum of x and y
	 */
	public static void main(String[] args) throws Exception
	{
		int[] moves = Move.getMove();
		if (moves != null)
		{
			for (int j = 0; j < moves.length; j++)
			{
				System.out.println(j + "\t" + moves[j]);
			}
		}
		else
		{
			System.out.println(moves);
		}
		
	}
}
